﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=7.3
@EndOfDesignText@
'March 4 '22 Perfect Project

'TableLite CustomView
'Initialize
'Version 1.0 This class is based on the Table class version 2.24


' these Event lines are useful for a library compilation for the IDE autocompletion
#Event: CellClick(col As Int, row As Int)
#Event: CellLongClick(col As Int, row As Int)
#Event: HeaderClick(col As Int)
#Event: HeaderLongClick(col As Int)
#Event: ScrollChanged(PosX As Int, PosY As Int)
' these RaisesSynchronousEvents lines are useful for a library compilation
#RaisesSynchronousEvents: CellClick
#RaisesSynchronousEvents: CellLongClick
#RaisesSynchronousEvents: HeaderClick
#RaisesSynchronousEvents: HeaderLongClick
#RaisesSynchronousEvents: ScrollChanged

#DesignerProperty: Key: NumberOfColumns, DisplayName: Numberofcolumns, FieldType: Int, DefaultValue: 3, Description: Number of columns.
#DesignerProperty: Key: MultiSelect, DisplayName: MultiSelect, FieldType: Boolean, DefaultValue: False, Description: Allows more than one selected row.
#DesignerProperty: Key: RowHeight, DisplayName: Row height, FieldType: Int, DefaultValue: 40, Description: Row height.
#DesignerProperty: Key: HeaderHeight, DisplayName: Header height, FieldType: Int, DefaultValue: 40, Description: Header height.
#DesignerProperty: Key: LineWidth, DisplayName: LineWidth, FieldType: Int, DefaultValue: 1, MinRange: 1, MaxRange: 10, Description: Line width in dips.
#DesignerProperty: Key: TextSize, DisplayName: Text size, FieldType: Int, DefaultValue: 14, Description: Text size.
#DesignerProperty: Key: TextAlignmentH, DisplayName: TextAlignmentH, FieldType: String, DefaultValue: CENTER, List: LEFT|CENTER|RIGHT, Description: Set the horizontal text horizontal alignment.
#DesignerProperty: Key: TextAlignmentV, DisplayName: TextAlignmentV, FieldType: String, DefaultValue: CENTER, List: TOP|CENTER|BOTTOM, Description: Set the vertical text alignment.
#DesignerProperty: Key: HeaderTextAlignmentH, DisplayName: HeaderTextAlignmentH, FieldType: String, DefaultValue: CENTER, List: LEFT|CENTER|RIGHT, Description:  Set the horizontal header text alignment.
#DesignerProperty: Key: HeaderTextAlignmentV, DisplayName: HeaderTextAlignmentV, FieldType: String, DefaultValue: CENTER, List: TOP|CENTER|BOTTOM, Description: Set the hvertical Header text alignment.
#DesignerProperty: Key: HeaderColor, DisplayName: Header color, FieldType: Color, DefaultValue: 0xFF808080, Description: Header background color.
#DesignerProperty: Key: TableColor, DisplayName: Table color, FieldType: Color, DefaultValue: 0xFFD3D3D3, Description: Table background color.
#DesignerProperty: Key: HeaderTextColor, DisplayName: Header text color, FieldType: Color, DefaultValue: 0xFFFFFFFF, Description: Table background color.
#DesignerProperty: Key:	CellTextColor, DisplayName: Cell text color, FieldType: Color, DefaultValue: 0xFF000000, Description: Table background color.
#DesignerProperty: Key:	Row1Color, DisplayName: Row 1 color, FieldType: Color, DefaultValue: 0xFFFFFFFF, Description: Row1 background color.
#DesignerProperty: Key:	Row2Color, DisplayName: Row 2 color, FieldType: Color, DefaultValue: 0xFF98F5FF, Description: Row2 background color.
#DesignerProperty: Key:	SelectedRowColor, DisplayName: Selected row color, FieldType: Color, DefaultValue: 0xFF007FFF, Description: Selected row background color.
#DesignerProperty: Key:	SelectedRowTextColor, DisplayName: SelectedRowTextColor, FieldType: Color, DefaultValue: 0xFF007FFF, Description: Selected row text color.
#DesignerProperty: Key:	SelectedCellColor, DisplayName: Selected cell color, FieldType: Color, DefaultValue: 0xFFFC8EAC, Description: Selected row background color.
#DesignerProperty: Key:	SelectedCellTextColor, DisplayName: SelectedCellTextColor, FieldType: Color, DefaultValue: 0xFFFC8EAC, Description: Selected cell text color.
#DesignerProperty: Key:	SortColumn, DisplayName: SortColumn, FieldType: Boolean, DefaultValue: False, Description: A click on a header sorts this column. True = Sorts columns. False = doesn't sort columns.
#DesignerProperty: Key:	SortBitmapWidth, DisplayName: SortBitmapWidth, FieldType: Int, DefaultValue: 10, Description: Width of the sorting bitmap. Valid only with SortColumn = True.
#DesignerProperty: Key:	SortBitmapColor, DisplayName: SortBitmapColor, FieldType: Color, DefaultValue: 0xFFFFFF00, Description: Color of the sorting bitmap. Valid only with SortColumn = True.
#DesignerProperty: Key:	FastScroll, DisplayName: FastScroll, FieldType: Boolean, DefaultValue: False, Description: Allows the FastScroll feature.
#DesignerProperty: Key:	FastScrollMinItems, DisplayName: FastScrollMinItems, FieldType: Int, DefaultValue: 50, Description: Sets the number minumum of items before the fast scroll method is activated.
#DesignerProperty: Key:	FastScrollColumnIndex, DisplayName: FastScrollColumnIndex, FieldType: Int, DefaultValue: 0, Description: Sets the column idex for the display in the fast scroll label.
#DesignerProperty: Key:	FastScrollShowLabel, DisplayName: FastScrollShowLabel, FieldType: Boolean, DefaultValue: True, Description: Shows the FastScroll label.
#DesignerProperty: Key:	FastScrollFixedLabel, DisplayName: FastScrollFixedLabel, FieldType: Boolean, DefaultValue: False, Description: True = Shows the Label at the left in the middle. True = Shows the Label with the cursor.
#DesignerProperty: Key:	FastScrollLabelMaxChars, DisplayName: FastScrollLabelMaxChars, FieldType: Int, DefaultValue: 10, Description: Max number of characters for the fastscroll Label. Default value = 10.
#DesignerProperty: Key:	FastScrollLabelWidth, DisplayName: FastScrollLabelWidth, FieldType: Int, DefaultValue: 150, Description: Width of the fast scroll Label.
#DesignerProperty: Key:	FastScrollLabelHeight, DisplayName: FastScrollLabelHeight, FieldType: Int, DefaultValue: 30, Description: Height of the fast scroll Label.

Sub Class_Globals
	Private cCallBack As Object
	Private cEventName As String
	Public mBase As B4XView
	Private xui As XUI
	Public Tag As Object
	
	Type RowCol (Row As Int, Col As Int)

	
	Private StringUtils1 As StringUtils
#If B4A
		Private SV2 As ScrollView2D
#Else If B4i
	Private SV2 As ScrollView
#Else If B4J
	Private SV2 As ScrollPane
#End If
	Private xSV2 As B4XView
	Private pnlSV2 As B4XView

	Private Header As B4XView
	Private cLeft, cTop , cWidth, cHeight As Int
	Public HeaderNames As List
	Public SelectedRows As List ' selected rows ' convert to map!!!
	Private SelectedCol As Int 
	Public Data As List
	Private LabelsCache As List
	Private minVisibleRow, maxVisibleRow As Int
	Private IsVisible As Boolean
	Public visibleRows As Map
	Private mNumberOfColumns, ColumnWidths(), cColumnColors(), cTextColors(), cHeaderColors(), cHeaderTextColors(), DataWidths(), HeaderWidths() As Int
	Private cColumnDataType() As String
	Private cRowHeight, cHeaderColor, cTableColor, cTextColor, cHeaderHeight, cHeaderTextColor As Int
	Private cAutomaticWidths = False As Boolean
	Private cTextSize As Float
	Private cAlignmentH As String
	Private cAlignmentV As String
	Private cAlignmentsH() As String
	Private cAlignmentsV() As String
	Private cAlignments0H() As String
	Private cAlignments0V() As String
	Private MultiAlignments = False As Boolean
	Private cHeaderAlignmentH = "CENTER" As String
	Private cHeaderAlignmentV = "CENTER" As String
	Private cHeaderAlignmentsH() As String
	Private cHeaderAlignmentsV() As String
	Private cHeaderAlignments0H() As String
	Private cHeaderAlignments0V() As String
	Private HeaderMultiAlignments = False As Boolean
	Private MultiFont = False As Boolean
	Private cFont As B4XFont
	Private cFonts() As B4XFont
	Private cFonts0() As B4XFont
	Private HeaderMultiFont = False As Boolean
	Private cHeaderFont As B4XFont
	Private cHeaderFonts() As B4XFont
	Private cHeaderFonts0() As B4XFont
	Private cLineWidth = Max(1, 1dip) As Int
	Private ExtraWidth = 12dip + cLineWidth	As Int
	Private SelectedRowColor(), RowColor1(), RowColor2() As Int
	Private cRowColor1, cRowColor2, cSelectedRowColor, cSelectedCellColor, cSelectedRowTextColor, cSelectedCellTextColor As Int
	Private cUseColumnColors = False As Boolean
	
	Private cSingleLine = True As Boolean		' does a label hold a single line text or multiline , need to be set right after call to initialize
	
	Private mMultiSelect As Boolean = False
	Private cAllowSelection = True As Boolean
	Private SavedWidths() As Int' to keep the user set widths for columns

	Public sortingDir As String = "ASC" 'ASC ascending of DESC as descending
	Public sortedCol As Int = -1 ' hold the sorted column -1 for none
	Private imvSortingView As B4XView

	Private imvAsc As B4XView	
	Private bmpAsc, bmpDes As B4XBitmap
	Private cvsAsc, cvsDes As B4XCanvas
	Private cSortColumn = True As Boolean
	Private cSortBitmapWidth As Int
	Private cSortBitmapHeight As Int
	Private cSortBitmapColor As Int

	Dim debug_counter As Long
	
	Public TableObject As xTableLite
	
	Private pnlTable As B4XView
	Private pnlSV2Height As Int
	Private mB4JScrollBarWidth As Int   'ignore

	Private pnlFastScroll As B4XView
	Private pnlFastScrollCursor As B4XView
	Private FScCursorWidth = 50dip As Int  'SSS 25 to 50  Fast scroll button width
	Private FScCursorHeight = 80dip As Int 'SSS 60 to 80
	Private FscLabelTopDelta As Int
	Private FScBackgroundColor As Int
	Private FScCursorCol1 = xui.Color_Blue As Int
	Private FScCursorCol2 = xui.Color_Yellow As Int
	Private lblFastScroll As B4XView
	Private FSY0, FSdY, FastScrollHeight As Int
	Private FScScale As Double
	Private FScTimer As Timer
	Private mFastScroll = False As Boolean
	Private FastScrollActive As Boolean
	Private mFastScrollColumnIndex = 0 As Int
	Private mFastScrollMinItems = 50 As Int
	Private mFastScrollShowLabel = True As Boolean
	Private mFastScrollFixedLabel = False As Boolean
	Private mFastScrollLabelMaxChars = 10 As Int
	Private mFastScrollLabelWidth = 150dip As Int
	Private mFastScrollLabelHeight = 30dip As Int
	
	'Private LongClickTime As Long
	'Private LongClickDelay = 500 As Long
	
	Private ChrPad = Chr(8196) As String
	Private ChrPad = " " As String
End Sub

Public Sub Initialize (CallBack As Object, EventName As String)
	cEventName = EventName
	cCallBack = CallBack
	
	'Table settings
	cHeaderColor = xui.Color_Gray
	cTableColor = xui.Color_LightGray
	cTextColor = xui.Color_Black
	cHeaderTextColor = xui.Color_White
	cTextSize = 14
	cFont = xui.CreateDefaultFont(cTextSize)
	cAlignmentH = "CENTER" 'change to LEFT or RIGHT for other alignments.
	cAlignmentV = "CENTER" 'change to TOP or RIGHT for other alignments.
	cRowColor1 = xui.Color_White
	cRowColor2 = 0xFF98F5FF
	cSelectedRowColor = 0xFF007FFF
	cSelectedRowTextColor = xui.Color_Black
	cSelectedCellColor = 0xFFFC8EAC
	cSelectedCellTextColor = xui.Color_Black
	cRowHeight = 50dip
	cHeaderHeight = cRowHeight
	
	cSortBitmapWidth = 10dip
	cSortBitmapColor = xui.Color_Yellow
	
	FScBackgroundColor = xui.Color_ARGB(48, 128, 128, 128)
	FScCursorCol1 = xui.Color_Blue
	FScCursorCol2 = xui.Color_Yellow

End Sub

Public Sub DesignerCreateView (Base As Object, Lbl As Label, Props As Map)
	mBase = Base
	Tag = mBase.Tag
	mBase.Tag = Me
	
	cLeft = mBase.Left
	cTop = mBase.Top
	cWidth = mBase.Width
	cHeight = mBase.Height
	mBase.Color = xui.Color_White
	
	'sets the text alignment property
	cAlignmentH = Props.Get("TextAlignmentH")
	cAlignmentV = Props.Get("TextAlignmentV")
	
	'sets the header text alignment property
	cHeaderAlignmentH = Props.Get("HeaderTextAlignmentH")
	cHeaderAlignmentV = Props.Get("HeaderTextAlignmentV")
	
	cLineWidth = DipToCurrent(Props.Get("LineWidth"))
	
	mNumberOfColumns = Props.Get("NumberOfColumns")
	'Log("mNumberOfColumns")  SSS attempt to get # of columns
	mMultiSelect = Props.GetDefault("MultiSelect", False)
	cHeaderColor = xui.PaintOrColorToColor(Props.Get("HeaderColor"))
	cTableColor = xui.PaintOrColorToColor(Props.Get("TableColor"))
	cHeaderTextColor = xui.PaintOrColorToColor(Props.Get("HeaderTextColor"))
	cTextColor = xui.PaintOrColorToColor(Props.Get("CellTextColor"))
	cRowColor1 = xui.PaintOrColorToColor(Props.Get("Row1Color"))
	cRowColor2 = xui.PaintOrColorToColor(Props.Get("Row2Color"))
	cSelectedRowColor = xui.PaintOrColorToColor(Props.Get("SelectedRowColor"))
	cSelectedCellColor = xui.PaintOrColorToColor(Props.Get("SelectedCellColor"))
	
	cTextSize = Props.Get("TextSize")
	
	cRowHeight = DipToCurrent(Props.Get("RowHeight"))
	cHeaderHeight = DipToCurrent(Props.Get("HeaderHeight"))

	cSortColumn = Props.GetDefault("SortColumn", False)
	cSortBitmapWidth = DipToCurrent(Props.Get("SortBitmapWidth"))
	cSortBitmapColor = xui.PaintOrColorToColor(Props.Get("SortBitmapColor"))
	
	mFastScroll = Props.GetDefault("FastScroll", False)
	mFastScrollMinItems = Props.GetDefault("FastScrollMinItems", 50)
	mFastScrollColumnIndex = Props.GetDefault("FastScrollColumnIndex", 0)
	mFastScrollShowLabel = Props.GetDefault("FastScrollShowLabel", True)
	mFastScrollFixedLabel = Props.GetDefault("FastScrollFixedLabel", False)
	mFastScrollLabelMaxChars = Props.GetDefault("FastScrollLabelMaxChars", 10)
	mFastScrollLabelWidth = DipToCurrent(Props.GetDefault("FastScrollLabelWidth", 150dip))
	mFastScrollLabelHeight = DipToCurrent(Props.GetDefault("FastScrollLabelHeight", 30dip))

	InitTable
End Sub

' add the xTableLight to a parent view of your choice (B4XView)
' Parent is the parent view 
' Left, Top as the start point of the table in the parent view
' Width and Height are the width and height of the table in the parent view, 
' note this includes empty space in case not enough lines exists - but the table will take the whole area.
Public Sub AddToParent(Parent As B4XView, Left As Int, Top As Int, Width As Int, Height As Int)
	cLeft = Left
	cTop = Top
	cWidth = Width
	cHeight = Height
	
	mBase = xui.CreatePanel("")
	mBase.Color = xui.Color_White
	Parent.AddView(mBase, cLeft, cTop , cWidth, cHeight)
	
	InitTable	
End Sub

Private Sub InitTable
	Data.Initialize
	visibleRows.Initialize
	
'	mBase.Tag = "Table"		'????
	TableObject = Me
	pnlTable = xui.CreatePanel("")
	Private xSV2 As B4XView

#If B4A
	SV2.Initialize(0, 0, "SV2")
	SV2.FadingEdges(False)
	pnlSV2 = SV2.Panel
#Else If B4i	
	SV2.Initialize("SV2", 0, 0)
	SV2.ShowsHorizontalIndicator = False
	SV2.ShowsVerticalIndicator = False
	SV2.Bounces = False
	pnlSV2 = SV2.Panel
#Else If B4J
	SV2.Initialize("SV2")
	SV2.Style = "-fx-font-size: 18px;" 'sets the scrollbar width to 20 pixels
	pnlSV2 = SV2.InnerNode
#End If
	xSV2 = SV2

	pnlSV2.Color = cTableColor
	
	innerClearAll(mNumberOfColumns, True)
	
	cFont = xui.CreateDefaultFont(cTextSize)
	cHeaderFont = xui.CreateDefaultFont(cTextSize)

	IsVisible = True
	Header = xui.CreatePanel("")
	Header.Color = cTableColor
	
	mBase.AddView(pnlTable, 0, 0, cWidth, cHeight)
	pnlTable.AddView(Header, 0, 0 , cWidth, cHeaderHeight)
	pnlTable.AddView(SV2, 0, Header.Height, cWidth, cHeight - Header.Height)
	
#If B4J
	mB4JScrollBarWidth = 20
#Else
	mB4JScrollBarWidth = 0
#End If

	pnlFastScroll = xui.CreatePanel("pnlFastScroll")
	pnlFastScroll.Color = FScBackgroundColor
	pnlFastScroll.Visible = False
	pnlTable.AddView(pnlFastScroll,  cWidth - FScCursorWidth, xSV2.Top, FScCursorWidth, xSV2.Height)
	pnlFastScrollCursor = xui.CreatePanel("")
	pnlFastScrollCursor.Color = xui.Color_White
	pnlFastScroll.AddView(pnlFastScrollCursor,  0, 0, FScCursorWidth, FScCursorHeight)
	Private ll As Label
	ll.Initialize("")
	lblFastScroll = ll
	lblFastScroll.SetColorAndBorder(xui.Color_White, 1dip, xui.Color_Black, 3dip)
	lblFastScroll.TextColor = xui.Color_Black
	lblFastScroll.SetTextAlignment("CENTER", "LEFT")
#If B4A
	ll.Padding = Array As Int(5dip, 0, 0, 0)	'????	
	ll.SingleLine = False
#Else If B4J
	Private jo = ll As JavaObject
	jo.RunMethod("setMouseTransparent", Array As Object(True)) 'transmits the events to the underlying node
	ll.WrapText = True
#Else
	ll.Multiline = True
#End If
	lblFastScroll.Visible = False
	If mFastScrollFixedLabel = False Then
		mBase.AddView(lblFastScroll,  cWidth - mFastScrollLabelWidth - FScCursorWidth, FscLabelTopDelta, mFastScrollLabelWidth, mFastScrollLabelHeight)
	Else
		mBase.AddView(lblFastScroll,  0, (xSV2.Height - mFastScrollLabelHeight) / 2, mFastScrollLabelWidth, mFastScrollLabelHeight)
	End If
	FScTimer.Initialize("FastScrollTimer",2000) 'SSS (f 1500) time visible: now 2 seconds

	InitFastScroll

	Dim ColumnWidths(mNumberOfColumns) As Int
	Dim HeaderWidths(mNumberOfColumns) As Int
	Dim DataWidths(mNumberOfColumns) As Int
	Dim SavedWidths(mNumberOfColumns) As Int
	Dim cColumnDataType(mNumberOfColumns) As String
	For i = 0 To mNumberOfColumns - 1
		ColumnWidths(i) = xSV2.Width / mNumberOfColumns
		HeaderWidths(i) = ColumnWidths(i)
		DataWidths(i) = ColumnWidths(i)
		SavedWidths(i) = ColumnWidths(i)
		cColumnDataType(i) = "TEXT"
	Next
#If B4i
	SV2.ContentWidth = xSV2.Width
	pnlSV2.Width = xSV2.Width
#Else
	pnlSV2.Width = xSV2.Width
#End If
'	SV2ScrollChanged(0, 0)
	
	InitFastScroll
	
	Private imv As ImageView
	imv.Initialize("")
	imvSortingView = imv

	InitializeSortingBitmaps
End Sub

' InitializeTable
' NumberOfColumns = number of columns including hidden ones
'                    enter 1 if you use either LoadSQLiteDB, LoadTableFromCSV or LoadTableFromCSV2
' cellAlignmentH = horizontal cell alignments of all cells text
' cellAlignmentV = vertical cell alignments of all cells text
Public Sub InitializeTable (NumberOfColumns As Int, cellAlignmentH As String, cellAlignmentV As String)
'	Initialize(CallbackModule, EventName)

	SelectedRows.Initialize
	cAlignmentH = cellAlignmentH
	cAlignmentV = cellAlignmentV

	mNumberOfColumns = NumberOfColumns
	Data.Initialize	'needed 
	
	Dim ColumnWidths(mNumberOfColumns) As Int
	Dim HeaderWidths(mNumberOfColumns) As Int
	Dim DataWidths(mNumberOfColumns) As Int
	Dim SavedWidths(mNumberOfColumns) As Int
	Dim cColumnDataType(mNumberOfColumns) As String
	For i = 0 To mNumberOfColumns - 1
		ColumnWidths(i) = cWidth / mNumberOfColumns
		HeaderWidths(i) = ColumnWidths(i)
		DataWidths(i) = ColumnWidths(i)
		SavedWidths(i) = ColumnWidths(i)
	Next
	
	innerClearAll(mNumberOfColumns, True)
End Sub

'initializes the sorting Bitmaps
Private Sub InitializeSortingBitmaps
	Private pthAsc, pthDes As B4XPath
	
	cSortBitmapHeight = cSortBitmapWidth / 2
	
	Private pnlAsc As B4XView
	pnlAsc = xui.CreatePanel("")
	pnlAsc.Width = cSortBitmapWidth
	pnlAsc.Height = cSortBitmapHeight
	Private imv As ImageView
	imv.Initialize("")
	imvAsc = imv
'	mBase.AddView(imvAsc, 0, 0, cSortBitmapWidth, cSortBitmapHeight)
	pnlTable.AddView(imvAsc, 0, 0, cSortBitmapWidth, cSortBitmapHeight)	'???????????
	cvsAsc.Initialize(pnlAsc)
	pthAsc.Initialize(0, 0)
	pthAsc.LineTo(cSortBitmapWidth, 0)
	pthAsc.LineTo(cSortBitmapHeight, cSortBitmapHeight)
	cvsAsc.ClearRect(cvsAsc.TargetRect)
	cvsAsc.DrawPath(pthAsc, cSortBitmapColor, True, 1dip)
	bmpAsc = cvsAsc.CreateBitmap

	cvsDes.Initialize(pnlAsc)
	pthDes.Initialize(0, cSortBitmapHeight)
	pthDes.LineTo(cSortBitmapHeight, 0)
	pthDes.LineTo(cSortBitmapWidth, cSortBitmapHeight)
	cvsDes.ClearRect(cvsDes.TargetRect)
	cvsDes.DrawPath(pthDes, cSortBitmapColor, True, 1dip)
	bmpDes = cvsDes.CreateBitmap
	pnlAsc.RemoveViewFromParent
End Sub

'draws the fast scroll cursor
Private Sub DrawFastScrollCursor
	Private pthArrow As B4XPath
	Private cvsFSc As B4XCanvas
	Private x1, x2, x3, y1, y2, dd, rr As Int
	Private rct As B4XRect
	
	rr = 7dip
	
	cvsFSc.Initialize(pnlFastScrollCursor)
	rct.Initialize(0, 0, FScCursorWidth, FScCursorHeight)
	cvsFSc.DrawRect(rct, xui.Color_Transparent, True, 1dip)
	
	cvsFSc.DrawCircle(rr, rr, rr, FScCursorCol1, True, 1dip)
	cvsFSc.DrawCircle(FScCursorWidth - rr, rr, rr, FScCursorCol1, True, 1dip)
	cvsFSc.DrawCircle(rr, FScCursorHeight - rr, rr, FScCursorCol1, True, 1dip)
	cvsFSc.DrawCircle(FScCursorWidth - rr, FScCursorHeight - rr, rr, FScCursorCol1, True, 1dip)

	rct.Initialize(rr, 0, FScCursorWidth - rr, rr)
	cvsFSc.DrawRect(rct, FScCursorCol1, True, 1dip)
	rct.Initialize(0, rr, FScCursorWidth, FScCursorHeight - rr)
	cvsFSc.DrawRect(rct, FScCursorCol1, True, 1dip)
	rct.Initialize(rr, FScCursorHeight - rr, FScCursorWidth, FScCursorHeight)
	cvsFSc.DrawRect(rct, FScCursorCol1, True, 1dip)

	cvsFSc.DrawLine(5dip, FScCursorHeight / 2 - 5dip, FScCursorWidth - 5dip, FScCursorHeight / 2 - 5dip, FScCursorCol2, 1dip)
	cvsFSc.DrawLine(5dip, FScCursorHeight / 2, FScCursorWidth - 5dip, FScCursorHeight / 2, FScCursorCol2, 1dip)
	cvsFSc.DrawLine(5dip, FScCursorHeight / 2 + 5dip, FScCursorWidth - 5dip, FScCursorHeight / 2 + 5dip, FScCursorCol2, 1dip)
	
	dd = 7dip
	x2 = FScCursorWidth / 2
	x1 = x2 - dd
	x3 = x2 + dd
	y2 = dd
	y1 = y2 + dd
	pthArrow.Initialize(x1, y1)
	pthArrow.LineTo(x3, y1)
	pthArrow.LineTo(x2, y2)
	cvsFSc.DrawPath(pthArrow, FScCursorCol2, True, 1dip)
	
	x2 = FScCursorWidth / 2
	x1 = x2 - dd
	x3 = x2 + dd
	y2 = FScCursorHeight - dd
	y1 = y2 - dd
	pthArrow.Initialize(x1, y1)
	pthArrow.LineTo(x3, y1)
	pthArrow.LineTo(x2, y2)
	cvsFSc.DrawPath(pthArrow, FScCursorCol2, True, 1dip)
	cvsFSc.Invalidate
End Sub

Private Sub pnlFastScroll_Touch (Action As Int, X As Float, Y As Float)
	Select Action
		Case 0	'DOWN
			If Y >= pnlFastScrollCursor.Top And Y <= pnlFastScrollCursor.Top + pnlFastScrollCursor.Height Then
				FSY0 = pnlFastScrollCursor.Top
				FSdY = Y - FSY0
				FastScrollActive = True
			End If
		Case 2	'MOVE
			If FastScrollActive = True Then
				Private Top, SV2Top As Int
				Top = Max(Y - FSdY, 0)
				Top = Min(Top, pnlFastScroll.Height - pnlFastScrollCursor.Height)
				pnlFastScrollCursor.Top = Top
				If mFastScrollFixedLabel = False Then
					lblFastScroll.Top = pnlFastScrollCursor.Top + FscLabelTopDelta
				End If
				SV2Top = Top / FScScale
				SetSV2VerticalScrollPosition(SV2Top)
			End If
		Case 1	'UP
			FScTimer.Enabled = True
	End Select
End Sub

Private Sub InitFastScroll
	pnlFastScroll.Top = xSV2.Top
	pnlFastScroll.Height = xSV2.Height
#If B4J
	FastScrollHeight = pnlFastScroll.Height
#Else
	FastScrollHeight = pnlFastScroll.Height - pnlFastScrollCursor.Height
#End If
	pnlFastScrollCursor.Top = GetSV2VerticalScrollPosition * FScScale
	FscLabelTopDelta = SV2.Top + (FScCursorHeight - mFastScrollLabelHeight) / 2
	If mFastScrollFixedLabel = False Then
		lblFastScroll.Top = pnlFastScrollCursor.Top + FscLabelTopDelta
	End If
	DrawFastScrollCursor
End Sub

Private Sub CalcFastScroll(Pos As Int)
	Private i, Top As Int
	Top = Pos * FScScale
	pnlFastScrollCursor.Top = Top
	If mFastScrollFixedLabel = False Then
		lblFastScroll.Top = Top + FscLabelTopDelta
	End If
	If Data.Size > 0 Then
		i = (Pos + xSV2.Height / 2) / cRowHeight
		Private str() As String
		str = Data.Get(i)
		lblFastScroll.Text = ChrPad & str(mFastScrollColumnIndex).SubString2(0, Min(str(mFastScrollColumnIndex).Length, mFastScrollLabelMaxChars))
'		lblFastScroll.Text = str(mFastScrollColumnIndex).SubString2(0, Min(str(mFastScrollColumnIndex).Length, mFastScrollLabelMaxChars))
'		lblFastScroll.Text = str(mFastScrollColumnIndex)
	End If
End Sub

Private Sub FastScrollTimer_Tick
	FScTimer.Enabled = False
	lblFastScroll.Visible = False
	pnlFastScroll.Visible = False
End Sub

'Clears the table
Public Sub ClearAll
	innerClearAll(mNumberOfColumns, True)
End Sub

'Sets the columns widths.
'Example: <code>Table1.SetColumnsWidths(Array As Int(100dip, 30dip, 30dip, 100%x - 160dip))</code>
Public Sub SetColumnsWidths(Widths() As Int)
	' clone (keep) Widths
	Dim col, row As Int
	
	Dim SavedWidths(Widths.Length) As Int
	Dim ColumnWidths(Widths.Length) As Int
	Dim HeaderWidths(Widths.Length) As Int
	If cAutomaticWidths = False Then
		For col = 0 To Widths.Length - 1
			SavedWidths(col) = Widths(col)
			ColumnWidths(col) = Widths(col)
			HeaderWidths(col) = Widths(col)
			DataWidths(col) = Widths(col)
		Next
	Else
		For col = 0 To Widths.Length - 1
			SavedWidths(col) = Widths(col)
			ColumnWidths(col) = Widths(col)
		Next
	End If
	
	Private v As B4XView
	Private w As Int
	Private Left As Int
	
	Left = cLineWidth
		
	For col = 0 To Widths.Length - 1
		v = Header.GetView(col)
		w = Max(2dip, Widths(col) - cLineWidth)
		v.Width = w
		v.Left = Left
		If w > 2dip Then
			Left = Left + w + cLineWidth
		End If
	Next
	Header.Width = Header.GetView(Widths.Length - 1).Left + Widths(Widths.Length - 1)
#If B4i
		SV2.ContentWidth = Header.Width
#Else
	pnlSV2.Width = Header.Width
#End If
	xSV2.Left = 0
#If B4J
	If Header.Width + mB4JScrollBarWidth < cWidth Then
		SV2.SetHScrollVisibility("NEVER")
		mBase.Width = Header.Width + mB4JScrollBarWidth
		pnlTable.Width = Header.Width + mB4JScrollBarWidth
		xSV2.Width = Header.Width + mB4JScrollBarWidth
	Else
		SV2.SetHScrollVisibility("ALWAYS")
		mBase.Width = cWidth
		pnlTable.Width = cWidth
		xSV2.Width = cWidth
	End If
#Else
		xSV2.Width = Min(Header.Width, cWidth)
		mBase.Width = cWidth
		pnlTable.Width = cWidth
#End If
	Header.Left = 0
	SetSV2HorizontalScrollPosition(0)
	Dim lbls() As B4XView
'		For row = 0 To visibleRows.Size - 1
	For Each row As Int In visibleRows.Keys
		lbls = visibleRows.Get(row)
		For col = 0 To lbls.Length - 1
			lbls(col).SetLayoutAnimated(0, Header.GetView(col).Left, lbls(col).Top, Header.GetView(col).Width, cRowHeight - cLineWidth)
		Next
	Next
	
	pnlFastScroll.Left = mBase.Width - pnlFastScroll.Width
	If mFastScrollFixedLabel = True Then
		lblFastScroll.Top = (SV2.Height - lblFastScroll.Height) / 2 + Header.Height
	Else
		lblFastScroll.Left = pnlFastScroll.Left - lblFastScroll.Width
	End If

	RefreshTable
End Sub

Public Sub GetColumnWidths As Int()
	Return SavedWidths
End Sub

Private Sub innerClearAll(vNumberOfColumns As Int, ClearData As Boolean)
	SelectedRows.Initialize
	pnlSV2.RemoveAllViews
	mNumberOfColumns = vNumberOfColumns
	Dim RowColor1(mNumberOfColumns) As Int
	Dim RowColor2(mNumberOfColumns) As Int
	Dim SelectedRowColor(mNumberOfColumns) As Int
	Dim cAlignmentsH(mNumberOfColumns) As String
	Dim cAlignmentsV(mNumberOfColumns) As String
	Dim cHeaderAlignmentsH(mNumberOfColumns) As String
	Dim cHeaderAlignmentsV(mNumberOfColumns) As String
	Dim cFonts(mNumberOfColumns) As B4XFont
	Dim cHeaderFonts(mNumberOfColumns) As B4XFont
	
	If cUseColumnColors = False Then
		For i = 0 To mNumberOfColumns - 1
			RowColor1(i) = cRowColor1
			RowColor2(i) = cRowColor2
			SelectedRowColor(i) = cSelectedRowColor
			If MultiAlignments = False Or cAlignments0H.Length < mNumberOfColumns Then
				cAlignmentsH(i) = cAlignmentH
				cAlignmentsV(i) = cAlignmentV
			Else
				cAlignmentsH(i) = cAlignments0H(i)
				cAlignmentsV(i) = cAlignments0V(i)
			End If
			If MultiFont = False  Or cFonts0.Length < mNumberOfColumns Then
				cFonts(i) = cFont
			Else
				cFonts(i) = cFonts0(i)
			End If
			
			If HeaderMultiAlignments = False  Or cHeaderAlignments0H.Length < mNumberOfColumns Then
				cHeaderAlignmentsH(i) = cHeaderAlignmentH
				cHeaderAlignmentsV(i) = cHeaderAlignmentV
			Else
				cHeaderAlignmentsH(i) = cHeaderAlignments0H(i)
				cHeaderAlignmentsV(i) = cHeaderAlignments0V(i)
			End If
			If HeaderMultiFont = False  Or cHeaderFonts0.Length < mNumberOfColumns Then
				cHeaderFonts(i) = cHeaderFont
			Else
				cHeaderFonts(i) = cHeaderFonts0(i)
			End If
		Next
	Else
		For i = 0 To mNumberOfColumns - 1
			Private col1, col2, col3 As Int
			col1 = cColumnColors(i)
			col2 = cColumnColors(i)
			col3 = cSelectedRowColor
			RowColor1(i) = col1
			RowColor2(i) = col2
			SelectedRowColor(i) = col3
			If MultiAlignments = False Or cAlignments0H.Length < mNumberOfColumns Then
				cAlignmentsH(i) = cAlignmentH
				cAlignmentsV(i) = cAlignmentV
			Else
				cAlignmentsH(i) = cAlignments0H(i)
				cAlignmentsV(i) = cAlignments0V(i)
			End If
			If MultiFont = False  Or cFonts0.Length < mNumberOfColumns Then
				cFonts(i) = cFont
			Else
				cFonts(i) = cFonts0(i)
			End If
			
			If HeaderMultiAlignments = False  Or cHeaderAlignments0H.Length < mNumberOfColumns Then
				cHeaderAlignmentsH(i) = cHeaderAlignmentH
				cHeaderAlignmentsV(i) = cHeaderAlignmentV
			Else
				cHeaderAlignmentsH(i) = cHeaderAlignments0H(i)
				cHeaderAlignmentsV(i) = cHeaderAlignments0H(i)
			End If
			If HeaderMultiFont = False  Or cHeaderFonts0.Length < mNumberOfColumns Then
				cHeaderFonts(i) = cHeaderFont
			Else
				cHeaderFonts(i) = cHeaderFonts0(i)
			End If
		Next
	End If
	
#If B4i
	SV2.ContentHeight = Data.Size * cRowHeight
	pnlSV2Height = SV2.ContentHeight
#Else
	pnlSV2.Height = Data.Size * cRowHeight
	pnlSV2Height = pnlSV2.Height
#End If

	'SelectedRow = -1
	SelectedCol = -1
	minVisibleRow = -1
	maxVisibleRow = 0
	If ClearData = True Then
		Data.Initialize
	End If
	LabelsCache.Initialize
	visibleRows.Initialize
	SetSV2VerticalScrollPosition(0)
	For i = 1 To 80 'fill the cache to avoid delay on the first touch
		LabelsCache.Add(CreateNewLabels)
	Next
	If IsVisible Then
#If B4A
		SV2_ScrollChanged(0, 0)
#Else If B4J
		SV2.VPosition = 0
		SV2.HPosition = 0
#Else
#End If
	End If
End Sub

#If B4A
Private Sub SV2_ScrollChanged(PosX As Int, PosY As Int)
	Scroll(PosX, PosY)

	If mFastScroll = True And Data.Size >= mFastScrollMinItems And Data.Size * cRowHeight > SV2.Height Then
		FScScale = FastScrollHeight / (pnlSV2Height - SV2.Height)
		pnlFastScroll.Visible = True
		If mFastScrollShowLabel = True Then
			lblFastScroll.Visible = True
		End If
		CalcFastScroll(PosY)
		FScTimer.Enabled = True
	End If
	
	If xui.SubExists(cCallBack, cEventName & "_ScrollChanged", 2) Then
		CallSub3(cCallBack, cEventName & "_ScrollChanged", PosX, PosY)
	End If
End Sub

#Else If B4J
Private Sub SV2_VScrollChanged (Position As Double)
	Private PosX, PosY As Int
	
	PosY = Position * (pnlSV2Height - xSV2.Height)
'	PosX = SV2.HPosition * (pnlSV2.Width - xSV2.Width)
	PosX = SV2.HPosition * (pnlSV2.Width - xSV2.Width + mB4JScrollBarWidth)
		Scroll(PosX, PosY)
	
	If mFastScroll = True And Data.Size >= mFastScrollMinItems And Data.Size * cRowHeight > SV2.Height Then
		Private NbRows, FSCursorHeight As Double
		NbRows = (xSV2.Height - 20) / cRowHeight	'number of visible rows
		'25 = min height of the vertical scroll cursor
		FSCursorHeight = Max(25, (xSV2.Height - 3 * 20) * NbRows / Data.Size)
		FScScale = (xSV2.Height - 3 * 20) * (Data.Size - NbRows) / Data.Size / (pnlSV2Height - SV2.Height - 3 * 20)
		FScScale = ((xSV2.Height - 3 * 20) - (xSV2.Height - 3 * 20) * NbRows / Data.Size) / (pnlSV2Height - SV2.Height - 3 * 20)
		FScScale = ((xSV2.Height - 3 * 20) - FSCursorHeight) / (pnlSV2Height - SV2.Height - 3 * 20)
'		pnlFastScroll.Visible = True	'not used in B4J
		If mFastScrollShowLabel = True Then
			lblFastScroll.Visible = True
		End If
		CalcFastScroll(PosY)
		FScTimer.Enabled = True
	End If

	If xui.SubExists(cCallBack, cEventName & "_ScrollChanged", 2) Then
		CallSub3(cCallBack, cEventName & "_ScrollChanged", PosX, PosY)
	End If
End Sub

Private Sub SV2_HScrollChanged (Position As Double)
	Private Pos, PosX, PosY As Int
	
	Pos = Position * (pnlSV2.Width - xSV2.Width + mB4JScrollBarWidth)
'	Pos = Position * (pnlSV2.Width - xSV2.Width)
	Header.Left = -Pos
	
	PosY = SV2.VPosition * (pnlSV2Height - xSV2.Height)
	PosX = Position * (pnlSV2.Width - xSV2.Width + mB4JScrollBarWidth)
	If xui.SubExists(cCallBack, cEventName & "_ScrollChanged", 2) Then
		CallSub3(cCallBack, cEventName & "_ScrollChanged", PosX, PosY)
	End If
End Sub
#Else
Private Sub SV2_ScrollChanged(OffsetX As Int, OffsetY As Int)
	Scroll(OffsetX, OffsetY)

	If mFastScroll = True And Data.Size >= mFastScrollMinItems And Data.Size * cRowHeight > SV2.Height Then
		FScScale = FastScrollHeight / (pnlSV2Height - SV2.Height)
		pnlFastScroll.Visible = True
		If mFastScrollShowLabel = True Then
			lblFastScroll.Visible = True
		End If
		CalcFastScroll(OffsetY)
		FScTimer.Enabled = True
	End If

	If xui.SubExists(cCallBack, cEventName & "_ScrollChanged", 2) Then
		CallSub3(cCallBack, cEventName & "_ScrollChanged", OffsetX, OffsetY)
	End If
End Sub
#End If

Private Sub SV2ScrollChanged(PosX As Double, PosY As Double)
#If B4J
	SV2_HScrollChanged (PosX)
	SV2_VScrollChanged (PosY)
#Else
	SV2_ScrollChanged(PosX, PosY)
#End If
End Sub

Private Sub Scroll(PosX As Int, PosY As Int)
	Dim currentMin, currentMax As Int
	currentMin = Max(0, PosY / cRowHeight - 30)
	currentMax = Min(Data.Size - 1, (PosY + SV2.Height) / cRowHeight + 30)
	If minVisibleRow > -1 Then
		If minVisibleRow < currentMin Then
			'need to hide the upper rows
			For I = minVisibleRow To Min(currentMin - 1, maxVisibleRow)
				HideRow(I)
			Next
		Else If minVisibleRow > currentMin Then
			'need to show the upper rows
			For I = currentMin To Min(minVisibleRow - 1, currentMax)
				ShowRow(I)
			Next
		End If
		If maxVisibleRow > currentMax Then
			'need to hide the lower rows
			For I = maxVisibleRow To Max(currentMax + 1, minVisibleRow) Step -1
				HideRow(I)
			Next
		Else If maxVisibleRow < currentMax Then
			'need to show the lower rows
			For I = currentMax To Max(maxVisibleRow + 1, currentMin) Step -1
				ShowRow(I)
			Next
		End If
	End If
	minVisibleRow = currentMin
	maxVisibleRow = currentMax
	Header.Left = -PosX
End Sub

'Adds a row to the table
'Example:<code>Table1.AddRow(Array As String("aaa", "ccc", "ddd", "eee"))</code>
Public Sub AddRow(Values() As String)
	If Values.Length <> mNumberOfColumns Then
		Log("Wrong number of values =" & Values.Length & " col=" & mNumberOfColumns)
		Return
	End If
	Data.Add(Values)
	Dim lastRow As Int
	lastRow = Data.Size - 1
	If lastRow < (GetSV2VerticalScrollPosition + SV2.Height) / cRowHeight + 1 Then
		ShowRow(lastRow)
	End If
#If B4i
	SV2.ContentHeight = Data.Size * cRowHeight
	pnlSV2Height = SV2.ContentHeight
#Else
	pnlSV2.Height = Data.Size * cRowHeight
	pnlSV2Height = pnlSV2.Height
#End If
	FScScale = FastScrollHeight / Data.Size	'?????
End Sub

'Adds a row to the table with automatic widths
'Example:<code>Table1.AddRow(Array As String("aaa", "ccc", "ddd", "eee"))</code>
Public Sub AddRowAutomaticWidth(Values() As String)
	If Values.Length <> mNumberOfColumns Then
		Log("Wrong number of values =" & Values.Length & " col=" & mNumberOfColumns)
		Return
	End If
	Data.Add(Values)
	Dim lastRow As Int
	lastRow = Data.Size - 1
	
	Dim changed = False As Boolean
	Dim width As Int
	Private txt As String
	If Data.Size = 1 Then
		For i = 0 To mNumberOfColumns - 1
			txt = ChrPad & HeaderNames.Get(i) & ChrPad
'			txt = HeaderNames.Get(i)
			If HeaderMultiFont = False Then
				width = MeasureTextWidth(txt, cHeaderFont) + ExtraWidth
			Else
				width = MeasureTextWidth(ChrPad & HeaderNames.Get(i) & ChrPad, cHeaderFonts(i)) + ExtraWidth
			End If
			ColumnWidths(i) = width
			SavedWidths(i) = width
			HeaderWidths(i) = width
			DataWidths(i) = width
		Next
	End If
	For i = 0 To mNumberOfColumns - 1
		If MultiFont = False Then
			width = MeasureTextWidth(ChrPad & Values(i) & ChrPad, cFont) + ExtraWidth
		Else
			width = MeasureTextWidth(ChrPad & Values(i) & ChrPad, cFonts(i)) + ExtraWidth
		End If
		If ColumnWidths(i) < width Then
			ColumnWidths(i) = width
			SavedWidths(i) = width
			HeaderWidths(i) = width
			DataWidths(i) = width
			changed = True
		End If
	Next

	If changed = True Then
		SetColumnsWidths(ColumnWidths)
	End If
	
	Private TopRow As Int
#If B4A
	TopRow = SV2.VerticalScrollPosition
#Else If B4J
	TopRow = SV2.VPosition * pnlSV2Height / xSV2.Height
#Else
	TopRow = SV2.ScrollOffsetY
#End If
	If lastRow < (TopRow + xSV2.Height) / cRowHeight + 1 Then
		ShowRow(lastRow)
	End If
#If B4i
	SV2.ContentHeight = Data.Size * cRowHeight
	pnlSV2Height = SV2.ContentHeight
#Else
	pnlSV2.Height = Data.Size * cRowHeight
	pnlSV2Height = pnlSV2.Height
#End If
End Sub

' draw a Row, now col is hidden (width <2)
Private Sub ShowRow(Row As Int)
	If visibleRows.ContainsKey(Row) Then Return
	'Log("ShowRow: " & Row)
	Dim lbls() As B4XView
	Dim values() As String
	lbls = GetLabels(Row)
	values = Data.get(Row)
	visibleRows.Put(Row, lbls)
	Dim rowColor() As Int
	Private txtColor As Int
	If (SelectedRows.indexof(Row) <> -1 )Then
		rowColor = SelectedRowColor
		txtColor = cSelectedRowTextColor
	Else If Row Mod 2 = 0 Then
		rowColor = RowColor1
		txtColor = cTextColor
	Else
		rowColor = RowColor2
		txtColor = cTextColor
	End If
	For i = 0 To lbls.Length - 1
		If (Header.GetView(I).Width > 1 ) Then
			pnlSV2.AddView(lbls(i), Header.GetView(I).Left, Row * cRowHeight, Header.GetView(I).Width, cRowHeight - cLineWidth)

			lbls(i).Text = ChrPad & values(i) & ChrPad
'#If B4i
'			lbls(i).Text = ChrPad & values(i) & ChrPad
'#Else
'			lbls(i).Text = values(i)
'#End If
			lbls(i).TextColor = txtColor
			If i = SelectedCol And (SelectedRows.indexof(Row) <> -1) Then
				lbls(i).TextColor = cSelectedCellTextColor
				lbls(i).Color = cSelectedCellColor
			Else
				lbls(i).TextColor = txtColor
				lbls(i).Color = rowColor(i)
			End If
			If MultiAlignments = False Then
				lbls(i).SetTextAlignment(cAlignmentV, cAlignmentH)
			Else
				lbls(i).SetTextAlignment(cAlignmentsV(i), cAlignmentsH(i))
			End If
		End If
	Next
End Sub

Private Sub IsRowVisible(Row As Int) As Boolean		'ignore
	Return Row < (GetSV2VerticalScrollPosition + xSV2.Height) / (cRowHeight + 1) And _
		Row > GetSV2VerticalScrollPosition / cRowHeight
End Sub

Private Sub HideRow (Row As Int)
	'Log("HideRow: " & Row)
	Dim lbls() As B4XView
	lbls = visibleRows.get(Row)
	If lbls = Null Then 
'		Log("HideRow: (null) " & Row)
		Return
	End If
	For I = 0 To lbls.Length - 1	
		lbls(I).RemoveViewFromParent
	Next
	visibleRows.Remove(Row)
	LabelsCache.Add(lbls)
End Sub

Private Sub GetLabels(Row As Int) As B4XView()
	Dim lbls() As B4XView
	If LabelsCache.Size > 0 Then
		'Log("from cache")
		lbls = LabelsCache.get(LabelsCache.Size - 1)
		LabelsCache.RemoveAt(LabelsCache.Size - 1)
	Else
		lbls = CreateNewLabels		
	End If
	For I = 0 To lbls.Length - 1
		Dim rc As RowCol
		rc = lbls(I).Tag
		rc.Row = Row
	Next
	Return lbls
End Sub

Private Sub CreateNewLabels As B4XView()
	Dim lbls(mNumberOfColumns) As B4XView
	For i = 0 To mNumberOfColumns - 1
		Private rc As RowCol
		rc.Col = i
		Private lb As Label
		lb.Initialize("Cell")
		Private lbl As B4XView
		lbl = lb
		lbl.TextSize = cTextSize
		
		If cUseColumnColors = False Then
			lbl.TextColor = cTextColor
		Else
			lbl.TextColor = cTextColors(i)
		End If
		
		If MultiFont = False Then
			lbl.Font = cFont
		Else
			lbl.Font = cFonts(i)
		End If

#If B4A
		lb.SingleLine = cSingleLine
#Else If B4J
		lb.WrapText = Not(cSingleLine)
#Else
		lb.MultiLine = Not(cSingleLine)
#End If
'		SetPadding(lbl, 4dip, 2dip, 4dip, 2dip)	'???Chr(8196)
		lbl.Tag = rc
		lbls(i) = lbl
	Next
	Return lbls
End Sub

'Set the headers values
'Example:<code>Table1.SetHeader(Array As String("Col1", "Col2", "Col3"))</code>
Public Sub SetHeader(Values() As String)
	Private col As Int

	Header.RemoveAllViews
	HeaderNames.Initialize2(Values)

	Private Left = 0 As Int
'	Private Left = cLineWidth As Int
	Private Change = 0 As Int
	Private w As Int
	For col = 0 To mNumberOfColumns - 1
		Private lb As Label
		Private lbl As B4XView
		lb.Initialize("Header")
		lbl = lb
		If HeaderMultiAlignments = False Then
			lbl.SetTextAlignment(cHeaderAlignmentV, cHeaderAlignmentH)
		Else
			lbl.SetTextAlignment(cHeaderAlignmentsV(col), cHeaderAlignmentsH(col))
		End If
		
		If HeaderMultiFont = False Then
			lbl.Font = cHeaderFont
		Else
			lbl.Font = cHeaderFonts(col)
		End If
		
		lbl.TextSize = cTextSize
		
'		SetPadding(lbl, 4dip, 2dip, 4dip, 2dip)	'???

		If cUseColumnColors = False Or cHeaderTextColors.Length <> mNumberOfColumns Then
			lbl.Color = cHeaderColor
			lbl.TextColor = cHeaderTextColor
		Else
			lbl.Color = cHeaderColors(col)
			lbl.TextColor = cHeaderTextColors(col)
		End If

		lbl.Text = ChrPad & Values(col) & ChrPad
'#If B4i
'		lbl.Text = ChrPad & Values(col) & ChrPad
'#Else	
'		lbl.Text = Values(col)
'#End If
		lbl.Tag = col'		
		w = Max(0, ColumnWidths(col) - cLineWidth)		' needed to make sure that the width has value > 0

		Header.AddView(lbl, Left, 0, w, cHeaderHeight)

		If cAutomaticWidths = True Then
			If Values(col).Contains(CRLF) Then
				Dim str() As String
				Dim j As Int
				str = Regex.Split(CRLF, Values(col))
				HeaderWidths(col) = MeasureTextWidth(ChrPad & str(0) & ChrPad, lbl.Font) + ExtraWidth
				For j = 1 To str.Length - 1
					HeaderWidths(col) = Max(HeaderWidths(col),MeasureTextWidth(ChrPad & str(j) & ChrPad, lbl.Font)  + ExtraWidth)
				Next
			Else
				HeaderWidths(col) = MeasureTextWidth(Chr(8196) & Values(col) & Chr(8196), lbl.Font)  + ExtraWidth
			End If
			If HeaderWidths(col) > ColumnWidths(col) Then
				Change = 1
				ColumnWidths(col) = Max(HeaderWidths(col), ColumnWidths(col))
			Else If ColumnWidths(col) > HeaderWidths(col) And ColumnWidths(col) > DataWidths(col) Then
				Change = 1
				ColumnWidths(col) = Max(HeaderWidths(col), DataWidths(col))
			End If
		Else
			pnlSV2.Width = cWidth
		End If
		Left = Left + ColumnWidths(col)
	Next
	
	If Change = 1 Then
		SetColumnsWidths(ColumnWidths)
	End If
	Header.Left = - GetSV2HorizontalScrollPosition
End Sub

Private Sub Cell_LongClick
	'Log("Cell: long click")
	Dim rc As RowCol
	Dim L As B4XView
	L = Sender
	rc = L.Tag
	'SelectRow(rc)
	If xui.SubExists(cCallBack, cEventName & "_CellLongClick", 2) Then
		CallSub3(cCallBack, cEventName & "_CellLongClick", rc.Col, rc.Row)
	End If
End Sub

Private Sub Header_LongClick
	'Log("Header: long click")
	Dim L As B4XView
	Dim col As Int
	L = Sender
	col = L.Tag
	If xui.SubExists(cCallBack, cEventName & "_HeaderLongClick", 1) Then
		CallSub2(cCallBack, cEventName & "_HeaderLongClick", col)
	End If
End Sub

#If B4J
Private Sub Cell_MousePressed(EventData As MouseEvent)
	LongClickTime = DateTime.Now + LongClickDelay
End Sub

Private Sub Cell_MouseReleased (EventData As MouseEvent)
	If DateTime.Now < LongClickTime Then
		Cell_Click
	Else
		Cell_LongClick
	End If
End Sub
#End If

Private Sub Cell_Click
	Dim rc As RowCol
	Dim L As B4XView
	L = Sender
	rc = L.Tag
'	SelectRow(rc.Row)
	SelectRow(rc)
	If xui.SubExists(cCallBack, cEventName & "_CellClick", 2) Then
		CallSub3(cCallBack, cEventName & "_CellClick", rc.Col, rc.Row)
	End If
End Sub

'Gets the value of the given cell.
Public Sub GetValue(Col As Int, Row As Int) As String
	Dim values() As String
	values = Data.get(Row)
	Return values(Col)
End Sub

'Sets the value of the given cell.
Public Sub SetValue(Col As Int, Row As Int, Value As String)
	Dim values() As String
	values = Data.get(Row)
	values(Col) = Value
	If visibleRows.ContainsKey(Row) Then
		Dim lbls() As Label
		lbls = visibleRows.get(Row)
		lbls(Col).Text = Chr(8196) & Value & Chr(8196)
'#If B4i
'		lbls(Col).Text = Chr(8196) & Value & Chr(8196)
'#Else
'		lbls(Col).Text = Value
'#End If
	End If
End Sub

Public Sub SelectRow(rc As RowCol)
	If Not(cAllowSelection) Then Return
	
	Dim prevIndex As Int
	Dim prev As Int ' if we select an alreday selected row, prev will be rc.row, else will be -1
	
	prevIndex = SelectedRows.indexof(rc.Row)	 ' -1 if selecting not a selected row	
	If (prevIndex <> -1 And mMultiSelect = False) Then
		' if IsMultiSelect = True no column change, only if IsMultiSelect = False
		SelectedCol = rc.col
		If visibleRows.ContainsKey(rc.Row) Then
			HideRow(rc.Row)
			ShowRow(rc.Row)
		End If
		Return	' comment this line if you want to unselect a line
	End If
	
	If (prevIndex = -1) Then
		If (mMultiSelect) Then
			SelectedRows.add(rc.Row) 'Select the new row
			prev = -1
		Else ' set selected to the new one
			' hide / show all selected rows		
			'Log ("get at zero: " & SelectedRows)
			If (SelectedRows.Size <> 0) Then 
				prev = SelectedRows.get(0) ' there should be only one here ever!!!, keep the unselected row in prev
				SelectedRows.set(0,rc.Row) ' change it to the new one
			Else 
				prev = -1
				SelectedRows.Add(rc.Row)
			End If
		End If
	Else ' multi select and found a row (unselect it)
		'Log ("multi select and found row")
		prev = SelectedRows.get(prevIndex) ' should be RC.row
		SelectedRows.RemoveAt(prevIndex) ' deselect the old selected row		
	End If
	'remove the color of previously selected row
	If prev > -1 Then
		If visibleRows.ContainsKey(rc.Row) Then
			HideRow(prev)
			ShowRow(prev)
		End If
	End If
	
	SelectedCol = rc.col
	If visibleRows.ContainsKey(rc.Row) Then
		HideRow(rc.Row)
		ShowRow(rc.Row)
	End If
End Sub

'Unselects the row for the given index
Public Sub UnselectRow(rc As RowCol)
	If Not(cAllowSelection) Then Return
	
	Dim prevIndex As Int
	
	prevIndex = SelectedRows.indexof(rc.Row)	 ' -1 if selecting not a selected row
	If (prevIndex <> -1 And mMultiSelect = False) Then
		' if IsMultiSelect = True no column change, only if IsMultiSelect = False
		SelectedCol = rc.col
		If visibleRows.ContainsKey(rc.Row) Then
			HideRow(rc.Row)
			ShowRow(rc.Row)
		End If
		Return	' comment this line if you want to unselect a line
	End If
End Sub

'Makes the given row visible.
Public Sub JumpToRow(Row As Int)
	Sleep(0)
	SetSV2VerticalScrollPosition(Row * cRowHeight)
End Sub

'Makes the given row visible and set it's row and colum as selected.
Public Sub JumpToRowAndSelect(Col As Int, Row As Int)
	Log("You may get this warning:")
	Log("Unexpected event (missing RaiseSynchronousEvents): sv_scrollchanged")
	Log("Ignore it, it is NOT harmful !")
	Dim rc As RowCol
	
	rc.Row = Row
	rc.Col = Col
	SelectRow(rc)
	Sleep(0)

	SetSV2VerticalScrollPosition(Row * cRowHeight)
	Private i, Left As Int
	If Col > 0 Then
		For i = 0 To Col - 1
			Left = Left + ColumnWidths(i)			
		Next	
	End If
	SetSV2HorizontalScrollPosition(Left)
End Sub

'Clears the previous table and loads the CSV file to the table.
'You should first add the Table to the activity before calling this method.
Public Sub LoadTableFromCSV(Dir As String, Filename As String, HeadersExist As Boolean)
	
	Dim List1 As List
	Dim h() As String
	
	cAutomaticWidths = False
	
	If HeadersExist Then
		Dim headers As List
		List1 = StringUtils1.LoadCSV2(Dir, Filename, ",", headers)
		Dim h(headers.Size) As String
		For i = 0 To headers.Size - 1
			h(i) = headers.get(i)
		Next
	Else
		List1 = StringUtils1.LoadCSV(Dir, Filename, ",")
		Dim firstRow() As String
		firstRow = List1.get(0)
		Dim h(firstRow.Length) As String
		For i = 0 To firstRow.Length - 1
			h(i) = "Col" & (i + 1)
		Next
	End If
	innerClearAll(h.Length, True)
	Dim ColumnWidths(mNumberOfColumns) As Int
	Dim HeaderWidths(mNumberOfColumns) As Int
	Dim DataWidths(mNumberOfColumns) As Int
	Dim cColumnDataType(mNumberOfColumns) As String
	For i = 0 To mNumberOfColumns - 1
		cColumnDataType(i) = "TEXT"
		ColumnWidths(i) = xSV2.Width / mNumberOfColumns
		HeaderWidths(i) = ColumnWidths(i)	
		DataWidths(i) = ColumnWidths(i)
	Next
	SetHeader(h)
	SetColumnsWidths(ColumnWidths)

	For i = 0 To List1.Size - 1
		Dim Row() As String
		Row = List1.get(i)
		AddRow(Row)
	Next
End Sub

'Clears the previous table and loads the CSV file to the table.
'You should first add the Table to the activity before calling this method.
'This method allows to set the separator character and automatic width calculation.
'Example:
'<code>Table1.LoadTableFromCSV2(File.DirAssets, "citylist.csv", True, ";", True)</code>
Public Sub LoadTableFromCSV2(Dir As String, Filename As String, HeadersExist As Boolean, SeparatorChar As String, AutomaticWidths As Boolean)
	
	Dim List1 As List
	Dim h() As String
	
	cAutomaticWidths = AutomaticWidths
	
	If HeadersExist Then
		Dim Headers As List
		List1 = StringUtils1.LoadCSV2(Dir, Filename, SeparatorChar, Headers)
		Dim h(Headers.Size) As String
		For i = 0 To Headers.Size - 1
			h(i) = Headers.get(i)
		Next
	Else
		List1 = StringUtils1.LoadCSV(Dir, Filename, SeparatorChar)
		Dim firstRow() As String
		firstRow = List1.get(0)
		Dim h(firstRow.Length) As String
		For i = 0 To firstRow.Length - 1
			h(i) = "Col" & (i + 1)
		Next
	End If
	innerClearAll(h.Length, True)
	Dim ColumnWidths(mNumberOfColumns) As Int
	Dim HeaderWidths(mNumberOfColumns) As Int
	Dim DataWidths(mNumberOfColumns) As Int
	Dim cColumnDataType(mNumberOfColumns) As String
	
	Dim col, Row As Int
	If AutomaticWidths = False Then
		For col = 0 To mNumberOfColumns - 1
			cColumnDataType(col) = "TEXT"
			ColumnWidths(col) = xSV2.Width / mNumberOfColumns
			HeaderWidths(col) = ColumnWidths(col)
			DataWidths(col) = ColumnWidths(col)
		Next
	Else
		If HeadersExist Then
			Dim strRow(mNumberOfColumns) As String
			strRow = List1.get(col)
			For col = 0 To mNumberOfColumns - 1
				HeaderWidths(col) = MeasureTextWidth(Chr(8196) & Headers.get(col) & Chr(8196), cHeaderFont)  + ExtraWidth
			Next
		End If
		For Row = 0 To List1.Size - 1
			Dim strRow(mNumberOfColumns) As String
			strRow = List1.get(Row)
			For col = 0 To mNumberOfColumns - 1
				DataWidths(col) = Max(DataWidths(col), MeasureTextWidth(Chr(8196) & strRow(col) & Chr(8196), cFonts(col)) + ExtraWidth)
			Next
		Next
		For col = 0 To mNumberOfColumns - 1
			cColumnDataType(col) = "TEXT"
			ColumnWidths(col) = Max(HeaderWidths(col), DataWidths(col))
		Next
	End If
	SetHeader(h)
	
	SetColumnsWidths(ColumnWidths)

	For i = 0 To List1.Size - 1
		Dim strRow() As String
		strRow = List1.get(i)
		AddRow(strRow)
	Next
End Sub

'Saves the table to a CSV file.
Public Sub SaveTableToCSV(Dir As String, Filename As String)
	Dim headers(mNumberOfColumns) As String
	For i = 0 To headers.Length - 1
		Dim L As Label
		L = Header.GetView(i)
		headers(i) = L.Text
	Next
	StringUtils1.SaveCSV2(Dir, Filename, ",", Data, headers)
End Sub

' new functunality added by nir -->
' remove a row
'row is the row number
Public Sub RemoveRow(Row As Int)	
	If (Row <0 Or Row > Data.Size-1) Then Return ' cant remove row outside of the table scope
	
	SV2ScrollChanged(GetSV2HorizontalScrollPosition, GetSV2VerticalScrollPosition) ' this strange call will set min/max visible area
	'Dim sr As Int ' to keep the previos selected row (in case IsMultiSelect is off)
	'sr = -1 ' not the selected row
	
	Dim prevIndex As Int 
	prevIndex = SelectedRows.IndexOf(Row) ' if the rmeoved one was selected or not/
	
	For i=0 To SelectedRows.Size -1 ' updated selection
		Dim keepSel As Int
		keepSel = SelectedRows.get(i)
		If (keepSel > Row) Then 			
			SelectedRows.set(i,keepSel-1) ' dec row number in all rows appear after the soon to be removed row
			' future optimization: hide and show all rows touched and that within visible range, for now we hide/show all rows in visible scope
		End If
	Next 
	
	If (prevIndex <> -1) Then 
		'sr = Row ' in case the row was selected keep it in sr
		SelectedRows.RemoveAt(prevIndex) ' removed the current row from the selected list
	End If
	
	Data.RemoveAt(Row)
	For i = minVisibleRow To maxVisibleRow ' hide all visible rows
		HideRow(i)
	Next

'	If IsMultiSelect = False Then
'		If sr = Row Then ' current selected row was deleted
'			sr = -1
'		Else If sr > Row Then
'			sr = sr - 1
'		End If
'	End If

	If Data.Size > 0 Then
		maxVisibleRow = Min(maxVisibleRow, Data.Size - 1) ' adjust visible rows
		minVisibleRow = Min(minVisibleRow, Data.Size - 1)
		For i = minVisibleRow To maxVisibleRow ' show all visible rows (should select the ones needed to be selected as well)
		'If (IsMultiSelect OR sr = i) Then HideRow(i) ' in multi select we made too much mess, we need to redraw the whole view (can be optimized if needed!)
			ShowRow(i)
		Next
	End If
	
#If B4i
	SV2.ContentHeight = Data.Size * cRowHeight
	pnlSV2Height = SV2.ContentHeight
#Else
	pnlSV2.Height = Data.Size * cRowHeight
	pnlSV2Height = pnlSV2.Height
#End If	
	
	SV2ScrollChanged(GetSV2HorizontalScrollPosition, Min(GetSV2VerticalScrollPosition, pnlSV2Height))
End Sub

' return array of strings hold all the values for a row.
Public Sub GetValues(Row As Int ) As String()
	Dim rowData() As String  = Data.get(Row) ' will throw an exception if row is not correct
	Dim tmp(mNumberOfColumns) As String
	For i=0 To mNumberOfColumns-1 ' copy the array
		tmp(i) =  rowData(i)
	Next
	Return tmp
End Sub

' insert a new row at a specific index
Public Sub insertRowAt (Row As Int, Values() As String) As Boolean
	If (Row < 0) Then Row = 0
	If (Row > Data.Size) Then 
		AddRow(Values)
		Return True		
	End If
	SV2ScrollChanged(GetSV2HorizontalScrollPosition, GetSV2VerticalScrollPosition) ' this strange call will set min/max visible area

	Dim L As List
	L.Initialize
	L.Add(Values)
	' fix selection
	For i=0 To SelectedRows.Size -1 ' updated selection
		Dim keepSel As Int
		keepSel = SelectedRows.get(i)
		If (keepSel >= Row) Then 			
			SelectedRows.set(i,keepSel+1) ' dec row number in all rows appear after the soon to be removed removed row
			' future optimization: hide and show all rows touched and that within visible range, for now we hide/show all rows in visible scope
		End If
	Next 
	For i = minVisibleRow To maxVisibleRow 
		HideRow(i)
	Next
	Data.AddAllAt(Row,L) ' now I can add the row
	
	SV2ScrollChanged(GetSV2HorizontalScrollPosition, GetSV2VerticalScrollPosition) ' this strange call will set min/max visible area

	For i = minVisibleRow To maxVisibleRow 
		ShowRow(i)
	Next
	
#If B4i
	SV2.ContentHeight = Data.Size * cRowHeight
	pnlSV2Height = SV2.ContentHeight
#Else
	pnlSV2.Height = Data.Size * cRowHeight
	pnlSV2Height = pnlSV2.Height
#End If
	SV2ScrollChanged(GetSV2HorizontalScrollPosition, Min(GetSV2VerticalScrollPosition, pnlSV2Height))
	Return False
End Sub

' update a row in the table
' row is the row number to update, Values is an array of string at the size of the number of columns
' return true if worked out, false if failed
Public Sub UpdateRow(Row As Int, Values () As String) As Boolean
	Dim i As Int
	If (Values.Length <> mNumberOfColumns Or Row <0 Or Row>Data.Size-1) Then
		Return False
	End If
	For i=0 To Values.Length-1
		SetValue(i,Row,Values(i))
	Next
	Return True
End Sub

' update a cell in the table
' col is the column index and row is the row index of the cell to update, Value is the cell content string
' return true if worked out, false if failed
Public Sub UpdateCell(Col As Int, Row As Int, Value As String) As Boolean
	If (Col < 0 Or Col > mNumberOfColumns - 1 Or Row < 0 Or Row>Data.Size-1) Then
		Return False
	End If
	SetValue(Col, Row, Value)
	Return True
End Sub

Public Sub clearSelection
    'SV_ScrollChanged(SV.HorizontalScrollPosition,SV.VerticalScrollPosition) ' this strange call will set min/max visible area	
	SelectedRows.Clear
	RefreshTable
End Sub

' refresh / redraw the visible part of the table
Public Sub RefreshTable
	SV2ScrollChanged(GetSV2HorizontalScrollPosition, GetSV2VerticalScrollPosition) ' this strange call will set min/max visible area
	For i = minVisibleRow To maxVisibleRow ' hide all visible rows
		HideRow(i)
	Next
	For i = minVisibleRow To maxVisibleRow ' hide all visible rows
		ShowRow(i)
	Next
End Sub

' refresh the Labels and redraw the visible part of the table
Private Sub RefreshLabels
	Private i, j As Int
		
	For i = minVisibleRow To maxVisibleRow ' hide all visible rows
		HideRow(i)
	Next
		
	For i = 0 To LabelsCache.Size - 1
		Private lbls() As B4XView
		lbls = LabelsCache.Get(i)
		For j = 0 To lbls.Length - 1
			If MultiFont = True Then
				lbls(j).Font = cFonts(j)
			Else
				lbls(j).Font = cFont
			End If
		Next
	Next
		
	For i = minVisibleRow To maxVisibleRow ' show all visible rows again
		ShowRow(i)
	Next
End Sub

' return true if the table is set to multi select 
Public Sub getMultiSelect As Boolean 
	Return mMultiSelect
End Sub

' set multi select flag, and clear the selected list (just in case)
' when IsMultiSelect is true, click on a not selected row will add that row to the selected list of rows, and click on an selected row will unselect it
' when IsMultiSelect is false, click on a row will select it (or reselect it if alreday selected)
Public Sub setMultiSelect(MultiSelect As Boolean)
	clearSelection
	mMultiSelect = MultiSelect
End Sub

Public Sub getAllowSelection As Boolean 
	Return cAllowSelection
End Sub

' set allow selection flag, and clear the selected list (just in case)
' AllowSelection = True by default
Public Sub setAllowSelection(AllowSelection As Boolean)
	cAllowSelection = AllowSelection
	If mBase.IsInitialized Then
		clearSelection
	End If
End Sub

' return the header panel
Public Sub getHeaderPanel As B4XView
	Return Header
End Sub

' return the selected row numbers as a list of int.
Public Sub getSelectedRows As List
	Dim sr As List
	sr.Initialize
	sr.AddAll(SelectedRows)
	Return sr
End Sub

' set column col to length '1' which means it will be hidden
Public Sub hideCol(col As Int) 
	Dim tmpWidths(SavedWidths.Length) As Int
	For i = 0 To SavedWidths.Length-1
		tmpWidths(i) = SavedWidths(i) 
	Next
	tmpWidths(col) = 1
	SetColumnsWidths(tmpWidths)	
End Sub

' unhide column col, and give it a new size ???
Public Sub unHideCol(col As Int, newSize As Int) 
	Dim tmpWidths(SavedWidths.Length) As Int
	For i=0 To SavedWidths.Length-1
		tmpWidths(i) = SavedWidths(i) 
	Next
	tmpWidths(col) = newSize
	SetColumnsWidths(tmpWidths)
End Sub

Public Sub getSize As Long
	Return Data.Size
End Sub

'Gets or sets the Table Left property
Public Sub setLeft(Left As Int)
	cLeft = Left
  mBase.Left = Left
End Sub

Public Sub getLeft As Int
   Return mBase.Left
End Sub

'Gets or sets the Table Left property
Public Sub setTop(Top As Int)
	cTop = Top
	mBase.Top = Top
End Sub

Public Sub getTop As Int
	Return mBase.Top
End Sub

'Gets or sets the Table Width property
Public Sub setWidth(Width As Int)
	cWidth = Width
	mBase.Width = Width
	pnlTable.Width = Width
		xSV2.Width = Width
End Sub

Public Sub getWidth As Int
	Return mBase.Width
End Sub

'Gets or sets the Table Height property
Public Sub setHeight(Height As Int)
	cHeight = Height
	mBase.Height = Height
	pnlTable.Height = Height
	xSV2.Height = Height - cHeaderHeight
'	SVFVScrollChanged(0)
	SV2ScrollChanged(0, 0)
	
	InitFastScroll
End Sub

Public Sub getHeight As Int
	Return mBase.Height
End Sub

'Gets or sets the Table Visible property
Public Sub setVisible(Visible As Boolean)
   mBase.Visible = Visible
End Sub

Public Sub getVisible As Boolean
	Return mBase.Visible
End Sub

'Gets or sets the grid line wisth
Public Sub setLineWidth(LineWidth As Int)
	cLineWidth = LineWidth
End Sub

Public Sub getLineWidth As Int
	Return cLineWidth
End Sub

#If B4J
Private Sub Header_MousePressed(EventData As MouseEvent)
	LongClickTime = DateTime.Now + LongClickDelay
End Sub

Private Sub Header_MouseReleased (EventData As MouseEvent)
	If DateTime.Now < LongClickTime Then
		Header_Click
	Else
		Header_LongClick
	End If
End Sub
#End If

Private Sub Header_Click
	Dim L As B4XView
	Dim col As Int
	L = Sender
	col = L.Tag
	
	If cSortColumn = True Then
		If (sortedCol = col) Then ' we are sorting the same col, reverse dir
			Private dir As String
			Select sortingDir
				Case "ASC"
					dir = "DESC" ' going up
				Case "DESC"
					dir = "ASC"
			End Select
		Else
			dir = "ASC" ' start with going up
		End If
		sortedCol = col
		sortingDir = dir
		If cColumnDataType(col) = "TEXT" Then
			sortTable(col, dir)
		Else
			sortTableNum(col, dir)
		End If
		showHeaderSorting(col, dir)
	End If
	
	If xui.SubExists(cCallBack, cEventName & "_HeaderClick", col) Then
		CallSub2(cCallBack, cEventName & "_HeaderClick", col)
	End If
End Sub

Public Sub showHeaderSorting(col As Int, dir As String)
'	Dim ll As Int = 10dip
	Dim L As Int ' calculate left
	Dim t As Int ' calculate top
	Dim View As B4XView
	Dim ParentView As B4XView
	
	imvSortingView.RemoveViewFromParent
	
	View = Header.GetView(col)
	ParentView = Header
	
	L = View.Left + View.Width - cSortBitmapWidth - 2dip
	
	If dir = "ASC" Then
'		imvSortingView.SetBackgroundImage(LoadBitmapSample(File.DirAssets, "sort_asc.png", ll, ll))
		imvSortingView.SetBitmap(bmpDes)
		t = View.Top + View.Height - cSortBitmapHeight - 2dip
	Else
'		imvSortingView.SetBackgroundImage(LoadBitmapSample(File.DirAssets, "sort_desc.png", ll, ll))
		imvSortingView.SetBitmap(bmpAsc)
		t = View.Top + View.Height - cSortBitmapHeight - 3dip
	End If

'	Dim View As View
'	View = Header.GetView(col)

	ParentView.AddView(imvSortingView, L, t, cSortBitmapWidth, cSortBitmapHeight)
End Sub

' code for sorting
' http://www.basic4ppc.com/forum/basic4android-getting-started-tutorials/8548-sorting-algorithms-teaching-basic4android.html#post47730

' sort the table by column number and direction
' col is the column number starting with 0
' dir as direction true = acc, false = dec
Public Sub sortTable(col As Int, dir As String)
'	Log ("sorting table for col:" & col)
	clearSelection
	debug_counter = 0
	'QuickSort(0,Data.Size-1, col, dir) ' TODO add dir
	SelectionSort(col, dir)
	RefreshTable
End Sub

Public Sub SelectionSort (col As Int, dir As String)
	Dim minIndex As Int
	For i = 0 To Data.Size- 1
		minIndex = i
		For j = i + 1 To Data.Size - 1
			Dim values1() As String = Data.get(j)
			Dim s1 As String = values1(col)
			Dim values2() As String = Data.get(minIndex)
			Dim s2 As String = values2(col)
			If dir = "ASC" Then
				If s1.CompareTo(s2) < 0 Then minIndex = j
			Else 
				If s1.CompareTo(s2) > 0 Then minIndex = j
			End If
		Next
		SwapList(i, minIndex)
	Next
End Sub

' code for sorting
' http://www.basic4ppc.com/forum/basic4android-getting-started-tutorials/8548-sorting-algorithms-teaching-basic4android.html#post47730

' sort the table by column number and direction
' col is the column number starting with 0
' dir as direction true = asc, false = dec
Public Sub sortTableNum(col As Int, dir As String)
	Log ("sorting table for col:" & col)
	clearSelection
	debug_counter = 0
	'QuickSort(0,Data.Size-1, col, dir) ' TODO add dir
	SelectionSortNum(col, dir)
	RefreshTable
End Sub

Public Sub SelectionSortNum (col As Int, dir As String)
	Dim minIndex As Int

	'check for none numeric values
	For i = 0 To Data.Size- 1
		Dim values1() As String = Data.Get(i)
		If Not(IsNumber(values1(col))) Then
			Log("There is a non numeric value in line " & i)
			Return
		End If
	Next
	
	For i = 0 To Data.Size- 1
		minIndex = i
		For j = i + 1 To Data.Size - 1
			Dim values1() As String = Data.get(j)
			Dim s1 As Double = values1(col)
			Dim values2() As String = Data.get(minIndex)
			Dim s2 As Double = values2(col)
			If dir.ToLowerCase = "asc" Then
				If s1 < s2 Then minIndex = j
			Else 
				If s1 > s2 Then minIndex = j
			End If
		Next
		SwapList(i, minIndex)
	Next
End Sub

Public Sub SwapList(index1 As Int, index2 As Int)
	Dim temp As Object
	temp = Data.get(index1)
	Data.set(index1,Data.get(index2))
	Data.set(index2,temp)
End Sub

' ------------------------------------ not in use for now ---------------------------------
' not in use, fail in big numbers where the value is the same
Public Sub QuickSort (left As Int, right As Int, col As Int, dir As Boolean)
	debug_counter = debug_counter +1
'	Log ("counter=" & debug_counter)
	If right > left Then
		Dim pivotIndex, pivotNewIndex As Int
		pivotIndex = Rnd(left, right + 1) 'max value is exclusive
		pivotNewIndex = Partition(left, right, pivotIndex, col,dir)
		QuickSort(left, pivotNewIndex - 1, col, dir)
		QuickSort(pivotNewIndex + 1, right, col, dir)
	End If
End Sub

Public Sub Partition (left As Int, right As Int, pivotIndex As Int, col As Int, dir As Boolean) As Int
	Dim storeIndex As Int
	Dim pivotValues() As String
	Dim pivotValue As String
	pivotValues = Data.get(pivotIndex)
	pivotValue = pivotValues(col)
	SwapList(pivotIndex, right)
	storeIndex = left
	For i = left To right - 1
		Dim values() As String = Data.get(i)
		Dim s As String = values(col)
		If (dir) Then 
			If s.CompareTo(pivotValue) < 0 Then ' dir is < acc, > dec
				SwapList(i, storeIndex)
				storeIndex = storeIndex + 1
			End If
		Else 
			If s.CompareTo(pivotValue) > 0 Then ' dir is < acc, > dec
				SwapList(i, storeIndex)
				storeIndex = storeIndex + 1
			End If
		End If 
	Next
	SwapList(storeIndex, right)
	Return storeIndex
End Sub

'sets the cell alignment for each column each column can have a diferent alignment
'Example:'<code>'Dim alignments() As Int
'AlignmentsV = Array As String ("TOP", "CENTER", "BOTTOM")
'AlignmentsH = Array As String ("LEFT", "CENTER", "RIGHT")
'Table1.SetCellAlignments(AlignmentsV, AlignmentsH)</code>
Public Sub SetCellAlignments(AlignmentsV() As String, AlignmentsH() As String)
	If AlignmentsH.Length <> mNumberOfColumns Then
'	ToastMessageShow("The number of alignments is not equal to the number of columns.", False)
		Return
	End If
	
	cAlignments0H = AlignmentsH
	cAlignments0V = AlignmentsV
	cAlignmentsH = cAlignments0H
	cAlignmentsV = cAlignments0V

	MultiAlignments = True
	If Data.Size > 0 Then
		RefreshTable
	End If
End Sub

'sets the cell alignments for each column all columns with the same alignment
'Example:
'<code>Table1.CellAlignment = Bit.OR(Gravity.CENTER_HORIZONTAL, Gravity.CENTER_VERTICAL)</code>
Public Sub SetCellAlignment(AlignmentV As String, AlignmentH As String)
	Dim i As Int
	
	cAlignmentH = AlignmentH
	cAlignmentV = AlignmentV
	Dim cAlignmentsH(mNumberOfColumns) As String
	Dim cAlignmentsV(mNumberOfColumns) As String
	For i = 0 To mNumberOfColumns - 1
		cAlignmentsH(i) = cAlignmentH
		cAlignmentsV(i) = cAlignmentV
	Next
	MultiAlignments = False
	If Data.Size > 0 Then
		RefreshTable
	End If
End Sub

'sets the header alignment for each column each column can have a diferent alignment
'Example:'<code>'Dim alignments() As Int
'AlignmentsV = Array As String "TOP", "CENTER", "BOTTOM")
'AlignmentsH = Array As String "LEFT", "CENTER", "RIGHT")
'Table1.SetHeaderAlignments(AlignmentsV, AlignmentsH)</code>
Public Sub SetHeaderAlignments(AlignmentsV() As String, AlignmentsH() As String)
	Dim i As Int
	
	If AlignmentsH.Length <> mNumberOfColumns Then
'		ToastMessageShow("The number of aligments is not equal to the number of columns.", False)
		Return
	End If
	
	Dim i As Int
	Dim cHeaderAlignments0H(mNumberOfColumns) As String
	Dim cHeaderAlignments0V(mNumberOfColumns) As String
	
	cHeaderAlignments0H = AlignmentsH
	cHeaderAlignments0V = AlignmentsV
	cHeaderAlignmentsH = cHeaderAlignments0H
	cHeaderAlignmentsV = cHeaderAlignments0V
	If Header.NumberOfViews > 0 Then
		For i = 0 To mNumberOfColumns - 1
			Dim lbl As B4XView
			lbl = Header.GetView(i)
			lbl.SetTextAlignment(cHeaderAlignmentsV(i), cHeaderAlignmentsH(i))
		Next
	End If
	HeaderMultiAlignments = True
End Sub


'sets or gets the header height
Public Sub setHeaderHeight(Height As Int)
	cHeaderHeight = Height
	If Header.IsInitialized Then
		Header.Height = cHeaderHeight
		For i = 0 To mNumberOfColumns - 1
			Dim lbl As B4XView
			lbl = Header.GetView(i)
			lbl.Height = Height
		Next
		SV2.Top = cHeaderHeight
		xSV2.Height = pnlTable.Height - cHeaderHeight
		InitFastScroll
	End If
End Sub

Public Sub getHeaderHeight As Int
	Return cHeaderHeight
End Sub

'sets or gets the header color
Public Sub setHeaderColor(Color As Int)
	cHeaderColor = Color
End Sub

Public Sub getHeaderColor As Int
	Return cHeaderColor
End Sub

'sets or gets the header text color
Public Sub setHeaderTextColor(Color As Int)
	cHeaderTextColor = Color
End Sub

Public Sub getHeaderTextColor As Int
	Return cHeaderTextColor
End Sub

'sets or gets the odd rows color
Public Sub setRowColor1(Color As Int)
	cRowColor1 = Color
	If mBase.IsInitialized Then
		innerClearAll(mNumberOfColumns, True)
	End If
End Sub

Public Sub getRowColor1 As Int
	Return cRowColor1
End Sub

'sets or gets the even rows color
Public Sub setRowColor2(Color As Int)
	cRowColor2 = Color
	If mBase.IsInitialized Then
		innerClearAll(mNumberOfColumns, True)
	End If
End Sub

Public Sub getRowColor2 As Int
	Return cRowColor2
End Sub

'sets or gets the selected row color
Public Sub setSelectedRowColor(Color As Int)
	cSelectedRowColor = Color
	If mBase.IsInitialized Then
		innerClearAll(mNumberOfColumns, True)
	End If
End Sub

Public Sub getSelectedRowColor As Int
	Return cSelectedRowColor
End Sub

'sets or gets the selected cell color
Public Sub setSelectedCellColor(Color As Int)
	cSelectedCellColor = Color
	If mBase.IsInitialized Then
		innerClearAll(mNumberOfColumns, True)
	End If
End Sub

Public Sub getSelectedCellColor As Int
	Return cSelectedCellColor
End Sub

'sets or gets the table color (color of lines between cells)
Public Sub setTableColor(Color As Int)
	cTableColor = Color
	If SV2.IsInitialized = True Then
		pnlSV2.Color = cTableColor
		If Header.IsInitialized Then
			Header.Color = cTableColor
		End If
	End If
End Sub

Public Sub getTableColor As Int
	Return cTableColor
End Sub

'sets or gets the cell text color
Public Sub setTextColor(Color As Int)
	cTextColor = Color
	If SV2.IsInitialized = True Then
		Dim i As Int
		For i = 0 To pnlSV2.NumberOfViews - 1
			Dim lbl As B4XView
			lbl = pnlSV2.GetView(i)
			lbl.TextColor = cTextColor
		Next
	End If
End Sub

Public Sub getTextColor As Int
	Return cTextColor
End Sub

'sets or gets the cell text size
Public Sub setTextSize(Size As Float)
	cTextSize = Size
	
	Private i As Int
	
	If Header.IsInitialized Then
		For i = 0 To Header.NumberOfViews - 1
			Dim lbl As B4XView
			lbl = Header.GetView(i)
			lbl.TextSize = cTextSize
		Next
	End If

	If SV2.IsInitialized = True Then
		For i = 0 To pnlSV2.NumberOfViews - 1
			Dim lbl As B4XView
			lbl = pnlSV2.GetView(i)
			lbl.TextSize = cTextSize
		Next
	End If
End Sub

Public Sub getTextSize As Float
	Return cTextSize
End Sub

'sets or gets the row height
Public Sub setRowHeight(RowHeight As Int)
	If cRowHeight = cHeaderHeight Then
		setHeaderHeight(RowHeight)
	End If
	cRowHeight = RowHeight
End Sub

Public Sub getRowHeight As Int
	Return cRowHeight
End Sub

'Sets different Fonts for columns
'If Fonts() is an array with only one Font this one is applied to all columns.
'This method must be called before filling the table
'Example code:
'<code>Dim tf() As B4XFont
'tf = Array As B4XFont(Font.DEFAULT, Font.DEFAULT_BOLD, , Font.DEFAULT, Font.DEFAULT_BOLD)
'Table1.SetFonts(tf)</code>
Public Sub SetFonts(Fonts() As B4XFont)
	If Fonts.Length = 1 Then
		cFont = Fonts(0)
		MultiFont = False
	Else
		If Fonts.Length <> mNumberOfColumns Then
'			ToastMessageShow("Invalid number of columns", False)
			Return
		End If
		
		cFonts0 = Fonts
		cFonts = cFonts0
		MultiFont = True
	End If
	
	If Data.Size > 0 Then
		SetAutomaticWidths
		RefreshLabels
	End If
End Sub

'load data from a SQLite database
'SQLite = SQL object
'Query = SQLite query
'AutomaticWidths  True > set the column widths automaticaly
'ATTENTION: if you expect REAL numbers with more than 7 digits you should use LoadSQLiteDB2
'SQLite limits REAL numbers converted to Strings like Floats (7 digits) not Doubles
'even 1000000.5 returns 1000000
Public Sub LoadSQLiteDB(SQLite As SQL, Query As String, AutomaticWidths As Boolean)
	Private col As Int
	Private RSet As ResultSet
	RSet = SQLite.ExecQuery(Query)
	
	cAutomaticWidths = AutomaticWidths
	mNumberOfColumns = RSet.ColumnCount
	innerClearAll(mNumberOfColumns, True)
	Dim Headers(mNumberOfColumns) As String
	Dim ColumnWidths(mNumberOfColumns) As Int
	Dim HeaderWidths(mNumberOfColumns) As Int
	Dim DataWidths(mNumberOfColumns) As Int
	Dim cColumnDataType(mNumberOfColumns) As String
	Dim col As Int
	Dim str As String
	
	For col = 0 To mNumberOfColumns - 1
		cColumnDataType(col) = "TEXT"
		Headers(col) = RSet.GetColumnName(col)
		If AutomaticWidths = False Then
			ColumnWidths(col) = 130dip
			HeaderWidths(col) = 130dip
			DataWidths(col) = 130dip
		Else
			If MultiFont = True Then
				HeaderWidths(col) = MeasureTextWidth(Chr(8196) & Headers(col) & Chr(8196), cHeaderFonts(col)) + ExtraWidth
			Else
				HeaderWidths(col) = MeasureTextWidth(Chr(8196) & Headers(col) & Chr(8196), cHeaderFont) + ExtraWidth
			End If
		End If
		DataWidths(col) = 0
	Next
	
	Do While RSet.NextRow
		For col = 0 To mNumberOfColumns - 1
			str = RSet.GetString2(col)
			If str <> Null Then
				If MultiFont = True Then
					DataWidths(col) = Max(DataWidths(col), MeasureTextWidth(Chr(8196) & str & Chr(8196), cFonts(col)) + ExtraWidth)
				Else
					DataWidths(col) = Max(DataWidths(col), MeasureTextWidth(Chr(8196) & str & Chr(8196), cFont) + ExtraWidth)
				End If
			End If
		Next
	Loop
	For col = 0 To mNumberOfColumns - 1
		ColumnWidths(col) = Max(HeaderWidths(col), DataWidths(col))
	Next
	
	SetHeader(Headers)
	SetColumnsWidths(ColumnWidths)
	
	RSet = SQLite.ExecQuery(Query)
	Do While RSet.NextRow
		Dim R(mNumberOfColumns), str As String
		For col = 0 To mNumberOfColumns - 1
			str = RSet.GetString2(col)
			If str <> Null Then
				R(col) = str
			Else
				R(col) = ""
			End If
		Next
		
#If B4J
'		Sleep(0) ' needed to display all entries when the Table is added by code.
#End If
	Loop
	RSet.Close
End Sub

'load data from a SQLite database
'SQLite = SQL object
'Query = SQLite query
'AutomaticWidths  True > set the column widths automatically
'ColumDataTypes Array of strings with the data types
'		"TEXT
'		"NUMBER"
'Example:
'<code>Table1.LoadSQLiteDB2(SQL1, "SELECT * FROM Test", True, Array As String("NUMBER", "TEXT", "NUMBER", "NUMBER"))</code>
Public Sub LoadSQLiteDB2(SQLite As SQL, Query As String, AutomaticWidths As Boolean, ColumnDataTypes() As String) As ResumableSub
	Dim RSet As ResultSet
	RSet = SQLite.ExecQuery(Query)
	
	cAutomaticWidths = AutomaticWidths
	mNumberOfColumns = RSet.ColumnCount
	innerClearAll(mNumberOfColumns, True)
	
	Dim Headers(mNumberOfColumns) As String
	Dim ColumnWidths(mNumberOfColumns) As Int
	Dim HeaderWidths(mNumberOfColumns) As Int
	Dim DataWidths(mNumberOfColumns) As Int
	Dim cColumnDataType(mNumberOfColumns) As String
	Dim col As Int
	Dim ii As Long
	Dim dd As Double
	Dim str As String
	For col = 0 To mNumberOfColumns - 1
'		If ColumnDataTypes(col) = "T" Then 'changed in version 3.01
		If ColumnDataTypes(col).CharAt(0) = "T" Then
			cColumnDataType(col) = "TEXT"
		Else
			cColumnDataType(col) = "NUMBER"
		End If
		Headers(col) = RSet.GetColumnName(col)
		If AutomaticWidths = False Then
			ColumnWidths(col) = 130dip
			HeaderWidths(col) = 130dip
			DataWidths(col) = 130dip
		Else
			If HeaderMultiFont = True Then
				HeaderWidths(col) = MeasureTextWidth(Chr(8196) & Headers(col) & Chr(8196), cHeaderFonts(col)) + ExtraWidth
			Else
				HeaderWidths(col) = MeasureTextWidth(Chr(8196) & Headers(col) & Chr(8196), cHeaderFont) + ExtraWidth
			End If
			DataWidths(col) = 0
			Do While RSet.NextRow
				str = RSet.GetString2(col)
				If str <> Null Then
					Select ColumnDataTypes(col)
						Case "I"
							ii = RSet.GetInt2(col)
							str = ii
						Case "R"
							dd = RSet.GetDouble2(col)
							str = dd
					End Select
				Else
					str = ""
				End If
				If MultiFont = True Then
					DataWidths(col) = Max(DataWidths(col), MeasureTextWidth(Chr(8196) & str & Chr(8196), cFonts(col)) + ExtraWidth)
				Else
					DataWidths(col) = Max(DataWidths(col), MeasureTextWidth(Chr(8196) & str & Chr(8196), cFont) + ExtraWidth)
				End If
			Loop
			
			ColumnWidths(col) = Max(HeaderWidths(col), DataWidths(col))
		End If
	Next
	SetHeader(Headers)
	SetColumnsWidths(ColumnWidths)

	RSet = SQLite.ExecQuery(Query)
	Do While RSet.NextRow
		Dim R(mNumberOfColumns), str As String
		For col = 0 To mNumberOfColumns - 1
			str = RSet.GetString2(col)
			If str = Null Then
				R(col) = ""
			Else
				Select ColumnDataTypes(col)
					Case "I"
						ii = RSet.GetLong2(col)
						R(col) = ii
					Case "R"
						dd = RSet.GetDouble2(col)
						R(col) = dd
					Case "T"
						R(col) = RSet.GetString2(col)
					Case Else '"BLOB"
						R(col) = ""
				End Select
			End If
		Next
		AddRow(R)
	Loop
	RSet.Close
	Return Null
End Sub

Public Sub RemoveView
	mBase.RemoveViewFromParent
End Sub

'Private Sub SetPadding(v As Label, Left As Int, Top As Int, Right As Int, Bottom As Int)
'#If B4A
'	v.Padding = Array As Int (Left, Top, Right, Bottom)
'#Else If B4i
'#Else If B4J
'	Private Style As String
'	Style = v.Style
'	Style = Style & "-fx-label-padding: " & Top & " " & Right & " " & Bottom & " " & Left & ";"
'	v.Style = Style
'#End If
'End Sub

'A Header click sorts the selected column If SortColum = True 
Public Sub setSortColumn(SortColumn As Boolean)
	cSortColumn = SortColumn
End Sub

Public Sub getSortColumn As Boolean
	Return cSortColumn
End Sub

'Uses different column colors insted of different row colors if UseColumnColors = True
Public Sub setUseColumnColors(UseColumnColors As Boolean)
	cUseColumnColors = UseColumnColors
	If cColumnColors.Length = 0 Then
		Dim i As Int
		Dim cColumnColors(mNumberOfColumns) As Int
		Dim cTextColors(mNumberOfColumns) As Int
		For i = 0 To mNumberOfColumns - 1
			If i Mod 2 = 0 Then
				cColumnColors(i) = cRowColor1
			Else
				cColumnColors(i) = cRowColor2
			End If
			cTextColors(i) = cTextColor
		Next
	End If
	
		If cHeaderColors.Length = 0 Then
		Dim i As Int
		Dim cHeaderColors(mNumberOfColumns) As Int
		Dim cHeaderTextColors(mNumberOfColumns) As Int
		For i = 0 To mNumberOfColumns - 1
			cHeaderColors(i) = cHeaderColor
			cHeaderTextColors(i) = cHeaderTextColor
		Next
	End If
End Sub

Public Sub getUseColumnColors As Boolean
	Return cUseColumnColors
End Sub

'Sets the colors for each column
Public Sub SetColumnColors(ColumnColors() As Int)
	cColumnColors = ColumnColors
End Sub

Public Sub GetColumnColors As Int()
	Return cColumnColors
End Sub

'Sets the colors for the text in each column
Public Sub SetTextColors(TextColors() As Int)
	cTextColors = TextColors
End Sub

Public Sub GetTextColors As Int()
	Return cTextColors
End Sub

'Sets the colors for each Header
Public Sub SetHeaderColors(HeaderColors() As Int)
	cHeaderColors = HeaderColors
End Sub

Public Sub GetHeaderColors As Int()
	Return cHeaderColors
End Sub

'Sets the colors for each Header text
Public Sub SetHeaderTextColors(HeaderTextColors() As Int)
	cHeaderTextColors = HeaderTextColors
End Sub

Public Sub GetHeaderTextColors As Int()
	Return cHeaderTextColors
End Sub

Public Sub getHeaderFont As B4XFont
	Return cHeaderFont
End Sub

'Sets or gets the same Font for all Header texts
Public Sub setHeaderFont(HeaderFont As B4XFont)
	cHeaderFont = HeaderFont
	HeaderMultiFont = False
	If Header.NumberOfViews > 0 Then
		For col = 0 To mNumberOfColumns - 1
			Private lbl As B4XView
			lbl = Header.GetView(col)
			lbl.Font = cHeaderFont
		Next
	End If
End Sub

'Sets the Font for each Header text
Public Sub SetHeaderFonts(HeaderFonts() As B4XFont)
	Private col As Int
	
	If HeaderFonts.Length = 1 Then
		cHeaderFont = HeaderFonts(0)
		HeaderMultiFont = False
		If Header.NumberOfViews > 0 Then
			For col = 0 To mNumberOfColumns - 1
				Private lbl As B4XView
				lbl = Header.GetView(col)
				lbl.Font = cHeaderFont
			Next
		End If
	Else
		If HeaderFonts.Length <> mNumberOfColumns Then
'			ToastMessageShow("Invalid number of columns", False)
			Log("SetHeaderFonts: Invalid number of columns")
			Return
		Else
			cHeaderFonts0 = HeaderFonts
			cHeaderFonts = cHeaderFonts0
			HeaderMultiFont = True
			If Header.NumberOfViews > 0 Then
				For col = 0 To mNumberOfColumns - 1
					Private lbl As B4XView
					lbl = Header.GetView(col)
					lbl.Font = cHeaderFonts(col)
				Next
			End If
		End If
	End If
End Sub

'True sets the cells to single line
Public Sub setSingleLine(SingleLine As Boolean)
	cSingleLine = SingleLine

	If LabelsCache.Size > 0 Then
		For row = 0 To LabelsCache.Size - 1
			Private lbls(mNumberOfColumns) As B4XView
			lbls = LabelsCache.Get(row)
			For col = 0 To mNumberOfColumns - 1
#If B4A
				lbls(col).As(Label).SingleLine = cSingleLine
#Else If B4J
				lbls(col).As(Label).WrapText = Not(cSingleLine)
#Else
				lbls(col).As(Label).Multiline = Not(cSingleLine)
#End If
			Next
		Next
	End If
End Sub

Public Sub getSingleLine As Boolean
	Return cSingleLine
End Sub

Public Sub SetAutomaticWidths
	Dim row, col As Int
	Dim Vals(mNumberOfColumns) As String
	Dim Width, Widths(mNumberOfColumns) As Int
	
	cAutomaticWidths = True
	
	For col = 0 To mNumberOfColumns - 1
		If MultiFont = False Then
			Widths(col) = MeasureTextWidth(Chr(8196) & HeaderNames.Get(col) & Chr(8196), cHeaderFont) + ExtraWidth
		Else
			Widths(col) = MeasureTextWidth(Chr(8196) & HeaderNames.Get(col) & Chr(8196), cHeaderFonts(col)) + ExtraWidth
		End If

		For row = 0 To Data.Size - 1
			Vals = Data.Get(row)
			If MultiFont = False Then
				Width = MeasureTextWidth(Chr(8196) & Vals(col) & Chr(8196), cFont) + ExtraWidth
			Else
				Width = MeasureTextWidth(Chr(8196) & Vals(col) & Chr(8196), cFonts(col)) + ExtraWidth
			End If
			If Widths(col) < Width Then
				Widths(col) = Width
			End If
		Next
	Next
	SetColumnsWidths(Widths)
End Sub

'Gets the base Panel of the Table
Public Sub getPanel As B4XView
	Return mBase
End Sub

'Scales the Table with the two scale factors.
'This routine is useful with Scale Module.
' It must be called before filling the Table.
'ScaleX = horizontal scale factor
'ScaleY = Vertical sclae factor
'ScaleAllDone = True if ScaleAll of the Scale Module was already used
'ScaleAllDone = False if ScaleAll of the Scale Module was not used
Public Sub ScaleTable(ScaleX As Double, ScaleY As Double, ScaleAllDone As Boolean)
	If Data.Size > 0 Then
'		ToastMessageShow("Table.ScaleTAble must be called before filling the Table", False) 
		Log("Table.ScaleTable must be called before filling the Table")
		Return
	End If

	cTextSize = cTextSize * Min(ScaleX, ScaleY)
	cLineWidth = cLineWidth * ScaleX
	ExtraWidth = ExtraWidth * ScaleX
	cRowHeight  = cRowHeight * ScaleY
	cHeaderHeight = cHeaderHeight * ScaleY
	For i = 0 To mNumberOfColumns - 1
		ColumnWidths(i) = ColumnWidths(i) * ScaleX
		DataWidths(i) = DataWidths(i) * ScaleX
		HeaderWidths(i) = HeaderWidths(i)	* ScaleX
		SavedWidths(i) = SavedWidths(i)	* ScaleX
	Next
		
	If ScaleAllDone = False Then
		cLeft = cLeft * ScaleX
		cTop = cTop * ScaleY
		cWidth = cWidth * ScaleX
		cHeight = cHeight * ScaleY
		
		mBase.Left = cLeft
		mBase.Top = cTop
		mBase.Width = cWidth
		mBase.Height = cHeight
		pnlTable.Left = cLeft
		pnlTable.Top = cTop
		pnlTable.Width = cWidth
		pnlTable.Height = cHeight
		Header.Height = cHeaderHeight
		xSV2.Width = cWidth
		SV2.Top = cHeaderHeight
		xSV2.Height = cHeight - cHeaderHeight
	End If

	lblFastScroll.Width = lblFastScroll.Width * ScaleX
	lblFastScroll.Height = lblFastScroll.Height * ScaleY
'		lblFastScroll.TextSize = lblFastScroll.TextSize * Min(ScaleX, ScaleY)
	lblFastScroll.TextSize = lblFastScroll.TextSize * ScaleY
	lblFastScroll.Left = lblFastScroll.Left * ScaleX
	lblFastScroll.Top = (xSV2.Height - lblFastScroll.Height) / 2 + Header.Height
	InitFastScroll

	CreateNewLabels
End Sub

'sets the data type of a column
'Column = index of the column
'DataType can be either "TEXT" or "NUMBER"
Public Sub SetColumnDataType(Column As Int, DataType As String)
	If Column < 0 Or Column > mNumberOfColumns - 1 Then
'		ToastMessageShow("Wrong column index", False)
		Return
	End If

	If DataType <> "TEXT" And DataType <> "NUMBER" Then
'		ToastMessageShow("Wrong data type only TEXT and NUMBER are allowed", False)
		Return		
	End If

	cColumnDataType(Column) = DataType
End Sub

'gets the data type of the given column 
'returns a Strings, the value is either TEXT or NUMBER
Public Sub GetColumnDataType(Column As Int) As String
	If Column < 0 Or Column > mNumberOfColumns - 1 Then
'		ToastMessageShow("Wrong column index", False)
		Return ""
	End If
	
	Return cColumnDataType(Column)
End Sub

'sets the data type of all columns
'Col = index of the column
'DataType() array, can be either "TEXT" or "NUMBER"
'Example:
'<code>SetColumnDataTypes(Array As String("NUMBER", "TEXT", "TEXT", "TEXT", "NUMBER")</code>
Public Sub SetColumnDataTypes(DataType() As String)
	If DataType.Length <> mNumberOfColumns Then
'		ToastMessageShow("Wrong number of columns", False)
		Return
	End If
	
	For Col = 0 To mNumberOfColumns - 1
		If DataType(Col) <> "TEXT" And DataType(Col) <> "NUMBER" Then
'			ToastMessageShow("Wrong data type only TEXT abd NUMBER are allowed", False)
			Return		
		End If	
	Next
	
	cColumnDataType = DataType
End Sub

'gets the data types of all current 
'returns an Array of Strings, the values are either TEXT or NUMBER
Public Sub GetColumnDataTypes As String()
	Return cColumnDataType
End Sub

'gets the number of columns, read only
Public Sub getNumberOfColumns As Int
	Return mNumberOfColumns
	
End Sub

'gets the number of rowsolumns, read only
Public Sub getNumberOfRows As Int
	Return Data.Size
	'Log("Data.Size") SSS atm
End Sub

'gets or sets the FastScroll property
'Allows a fast scroll method
'Default value False
Public Sub getFastScroll As Boolean
	Return mFastScroll
End Sub

Public Sub setFastScroll (FastScroll As Boolean)
	mFastScroll = FastScroll
	pnlFastScroll.Visible = False
	lblFastScroll.Visible = False
End Sub

'gets or sets the FastScrollMinItems property
'Sets the number minumum of items before the fast scroll method is activated.
'Default value 50
Public Sub getFastScrollMinItems As Int
	Return mFastScrollMinItems
End Sub

Public Sub setFastScrollMinItems (FastScrollMinItems As Int)
	mFastScrollMinItems = FastScrollMinItems
End Sub

'gets or sets the FastScrollColumnIndex property
'Sets the column idex for the display in the fast scroll label.
'Default value 0
Public Sub getFastScrollColumnIndex As Int
	Return mFastScrollColumnIndex
End Sub

Public Sub setFastScrollColumnIndex (FastScrollColumnIndex As Int)
	mFastScrollColumnIndex = Max(0, FastScrollColumnIndex)
	mFastScrollColumnIndex = Min(mFastScrollColumnIndex, mNumberOfColumns - 1)
End Sub

'gets or sets the FastScrollShowLabel property
'Displays the fast scroll label showing the text in the column set in the  property.
'Default value True
Public Sub getFastScrollShowLabel As Boolean
	Return mFastScrollShowLabel
End Sub

Public Sub setFastScrollShowLabel (FastScrollShowLabel As Boolean)
	mFastScrollShowLabel = FastScrollShowLabel
	lblFastScroll.Visible = False
End Sub

'gets or sets the FastScrollFixedLabel property
'Displays the fast scroll label showing the text in the column set in the  property.
'Default value True
Public Sub getFastScrollFixedLabel As Boolean
	Return mFastScrollFixedLabel
End Sub

Public Sub setFastScrollFixedLabel (FastScrollFixedLabel As Boolean)
	mFastScrollFixedLabel = FastScrollFixedLabel
	If mFastScrollFixedLabel = False Then
		lblFastScroll.Left = cWidth - mFastScrollLabelWidth - mFastScrollLabelWidth
		lblFastScroll.Top = pnlFastScrollCursor.Top + FscLabelTopDelta
	Else
		lblFastScroll.Left = 0
		lblFastScroll.Top = (xSV2.Height - lblFastScroll.Height) / 2 + Header.Height
	End If
	lblFastScroll.Visible = False
End Sub

'gets or sets the FastScrollLabelMaxChars property, default value = 10.
Public Sub getFastScrollLabelMaxChars As Int
	Return mFastScrollLabelMaxChars
End Sub

Public Sub setFastScrollLabelMaxChars(FastScrollLabelMaxChars As Int)
	mFastScrollLabelMaxChars = FastScrollLabelMaxChars
End Sub

'gets or sets the FastScrollLabelWidth property
Public Sub getFastScrollLabelWidth As Int
	Return mFastScrollLabelWidth
End Sub

Public Sub setFastScrollLabelWidth(Width As Int)
	mFastScrollLabelWidth = Width
	lblFastScroll.Width = mFastScrollLabelWidth
	If mFastScrollFixedLabel = False Then
		lblFastScroll.Left = cWidth - mFastScrollLabelWidth - mFastScrollLabelWidth
	Else
		lblFastScroll.Left = 0
	End If
End Sub

'gets or sets the FastScrollLabelHeight property
Public Sub getFastScrollLabelHeight As Int
	Return mFastScrollLabelWidth
End Sub

Public Sub setFastScrollLabelHeight(Height As Int)
	mFastScrollLabelHeight = Height
	lblFastScroll.Height = mFastScrollLabelHeight
	If mFastScrollFixedLabel = False Then
		FscLabelTopDelta = SV2.Top + (FScCursorHeight - mFastScrollLabelHeight) / 2
		lblFastScroll.Top = pnlFastScrollCursor.Top + FscLabelTopDelta
	Else
		lblFastScroll.Top = (xSV2.Height - lblFastScroll.Height) / 2 + Header.Height
	End If
End Sub

Public Sub MeasureTextWidth(Txt As String, MyFont As B4XFont) As Int
	Private rct As B4XRect
	rct = cvsAsc.MeasureText(Txt, MyFont)
	Return rct.Width
End Sub

Public Sub MeasureTextHeight(Txt As String, MyFont As B4XFont) As Int
	Private rct As B4XRect
	rct = cvsAsc.MeasureText(Txt, MyFont)
	Return rct.Height	
End Sub

Private Sub GetSV2VerticalScrollPosition As Double
#If B4A
	Return SV2.VerticalScrollPosition
#Else If B4J
	Return SV2.VPosition
#Else
	Return SV2.ScrollOffsetY
#End If
End Sub

Private Sub SetSV2VerticalScrollPosition(Position As Double)
#If B4A
	SV2.VerticalScrollPosition = Position
#Else If B4J
	SV2.VPosition = Position
#Else
	SV2.ScrollOffsetY = Position
#End If	
End Sub

Private Sub GetSV2HorizontalScrollPosition As Double
#If B4A
	Return SV2.HorizontalScrollPosition
#Else If B4J
	Return SV2.HPosition
#Else
	Return SV2.ScrollOffsetX
#End If
End Sub

Private Sub SetSV2HorizontalScrollPosition(Position As Double)
#If B4A
	SV2.HorizontalScrollPosition = Position
#Else If B4J
	SV2.HPosition = Position
#Else
	SV2.ScrollOffsetX = Position
#End If	
End Sub
